<?php
/**
 * Build menu
 */

	if (!defined("ENV")) exit();

	/* Initialize Admin Interfaces for Plugins */
	foreach ($cartPlugins->getAdminInterfaces() as $interface)
	{
		$pluginItems[$interface["group"]][] = $interface;
	}

	/**
	 * Functions for drawing popups menus
	 */
	
	function startMenu($menuId)
	{
		echo '<div class="items" id="'.$menuId.'Items"><ul>';
	}

	function endMenu()
	{
		echo '</ul></div>'."\r\n";
	}

	function menuItem($title, $url, $icon, $separator = false){
		echo '<li><a href="'.$url.'"><div class="item'.($separator?' separator':'').'" style="background-image:url(images/icons/'.$icon.'.gif);">'.$title.'</div></a></li>';
	}

	function displayPluginItems($pluginItems,$name)
	{
		if (!empty($pluginItems[$name]))
		{
			foreach($pluginItems[$name] as $i)
			{	
				menuItem($i["title"], $i["url"], $i["icon"]);
			}
		}
	}
	
	$topMenuButtons = array();
	
	/**
	 * Check privileges and draw menus
 	 */
	if (IsPrivilege(array("categories", "products", "all"), $auth_rights))
	{
		$topMenuButtons["menuCatalog"] = array("title"=>"Categories &<br>Products", "icon"=>"cubes", "alt"=>"Categories & Products");
		
		$is_items = false;
		startMenu("menuCatalog");
		if (IsPrivilege(array("products", "all"), $auth_rights))
		{
			menuItem("Manage Products", "admin.php?p=products", "ic_product");
			menuItem("Add a New Product", "admin.php?p=product&mode=insert", "ic_product_add");
			$is_items = true;
		}
		if (IsPrivilege(array("categories", "all"), $auth_rights))
		{
			menuItem("Manage Categories", "admin.php?p=categories", "ic_folder", $is_items);
			menuItem("Add a New Category", "admin.php?p=category&mode=insert", "ic_folder_new");
			$is_items = true;
		}
		if (IsPrivilege(array("products", "all"), $auth_rights))
		{
			menuItem("Manufacturers", "admin.php?p=manufacturers", "ic_manufacturer", $is_items);
			menuItem("Bulk Product Loader", "admin.php?p=bulk_products", "ic_product_loader");
			menuItem("Bulk Images Loader", "admin.php?p=bulk_images", "ic_images_loader");
			menuItem("Thumbnail Generator", "admin.php?p=thumbs_generator", "ic_thumbs_generator");
			menuItem("Global Attributes", "admin.php?p=products_attributes", "ic_properties");
			menuItem("Recommended Products", "admin.php?p=products_families", "ic_recommended");
			menuItem("Product Reviews", "admin.php?p=products_reviews", "ic_change_text");
		}
		displayPluginItems($pluginItems,"categories");
		displayPluginItems($pluginItems,"products");
		endMenu();
	}
	
	if (IsPrivilege(array("orders", "users", "all"), $auth_rights))
	{
		$topMenuButtons["menuUsersOrders"] = array("title"=>"Users &<br>Orders", "icon"=>"boxe", "alt"=>"Users & Orders");
		
		startMenu("menuUsersOrders");
		if (IsPrivilege(array("users", "all"), $auth_rights))
		{
			menuItem("Browse Users", "admin.php?p=users", "ic_users");
		}
		if (IsPrivilege(array("orders", "all"), $auth_rights))
		{
			menuItem("Browse Orders", "admin.php?p=orders", "ic_orders");
			menuItem("Export to QuickBooks", "admin.php?p=export_quickbooks", "ic_quickbooks", true);
		}
		displayPluginItems($pluginItems,"orders");
		displayPluginItems($pluginItems,"users");
		endMenu();
	}
	
	if (IsPrivilege(array("emails", "all"), $auth_rights))
	{
		$topMenuButtons["menuEmails"] = array("title"=>"Manage<br>Emails", "icon"=>"email", "alt"=>"Manage Emails");
		
		startMenu("menuEmails");
		menuItem("Newsletter Email Wizard", "admin.php?p=email_newsletter", "ic_mail_wizard");
		menuItem("Product Update Email Wizard", "admin.php?p=email_updates", "ic_mail_wizard");
		menuItem("Sent Email Archive", "admin.php?p=email_archive", "ic_email_sent");
		menuItem("Default Email Top & Bottom", "admin.php?p=email_top_bottom", "ic_change_text", true);
		menuItem("Notification Emails", "admin.php?p=email_notifications", "ic_notification");
		menuItem("Subscriber Email Addresses", "admin.php?p=email_list", "ic_email", true);
		menuItem("Import Email Addresses", "admin.php?p=emails_import", "ic_import");
		menuItem("Export User Email Addresses", "admin.php?p=users_emails&mode=users", "ic_export");
		menuItem("Export Subscriber Email Addresses", "admin.php?p=users_emails&mode=subscribers", "ic_export");
		menuItem("Check Bounced Email Addresses", "admin.php?p=email_check", "ic_email_check", true);
		displayPluginItems($pluginItems,"emails");
		endMenu();
	}
	
	if (IsPrivilege(array("admins", "all"), $auth_rights))
	{	
		$topMenuButtons["menuAdmins"] = array("title"=>"Manage<br>Admins", "icon"=>"admins", "alt"=>"Manage Admins");
		
		startMenu("menuAdmins");
		menuItem("Browse Administrators", "admin.php?p=admins", "ic_admins");
		menuItem("Create a New Account", "admin.php?p=admin&mode=insert", "ic_admin_add");
		menuItem("Activity Log", "admin.php?p=admins_log", "ic_settings");
		menuItem("Update Your Profile", "admin.php?p=profile", "ic_admin_profile", true);
		displayPluginItems($pluginItems,"admins");
		endMenu();
	}
	
	$isItems = false;
	if (IsPrivilege(array("global","business","content","database","all"), $auth_rights))
	{
		$topMenuButtons["menuSettings"] = array("title"=>"Cart<br>Settings", "icon"=>"settings", "alt"=>"Cart Settings");
		
		startMenu("menuSettings");
		if (IsPrivilege(array("global", "all"), $auth_rights))
		{
			menuItem("Global Cart Settings", "admin.php?p=settings", "ic_settings");
			displayPluginItems($pluginItems,"global");
			$isItems = true;
		}
		
		if (IsPrivilege(array("business", "all"), $auth_rights))
		{
			menuItem("Payment Methods", "admin.php?p=payment_methods", "ic_payment", $isItems);
			menuItem("Shipping Management", "admin.php?p=shipping", "ic_shipping");
			menuItem("Edit Taxes", "admin.php?p=taxes", "ic_tax");
			menuItem("Edit Discounts & Promo Codes", "admin.php?p=discounts", "ic_discount");
			displayPluginItems($pluginItems,"business");
			$isItems = true;
		}
		
		if (IsPrivilege(array("content", "all"), $auth_rights))
		{
			menuItem("Appearance Settings", "admin.php?p=design_settings", "ic_appearance", $isItems);
			menuItem("Edit Text Pages", "admin.php?p=pages", "ic_text_pages");
			menuItem("Forms Control / Custom Fields", "admin.php?p=forms_control", "ic_form");
			menuItem("File Manager", "admin.php?p=filemanager", "ic_filemanager");
			displayPluginItems($pluginItems,"content");
			$isItems = true;
		}
		if (IsPrivilege(array("database", "all"), $auth_rights))
		{
			menuItem("Database & Back-up Tools", "admin.php?p=backup_restore", "ic_database", $isItems);
			displayPluginItems($pluginItems,"database");
			$isItems = true;
		}
		endMenu();
	}
	
	if (IsPrivilege(array("stats", "all"), $auth_rights))
	{
		$topMenuButtons["menuStats"] = array("title"=>"Reports<br>&nbsp;", "icon"=>"stats", "alt"=>"Reports");
		
		startMenu("menuStats");
		menuItem("Charts", "admin.php?p=stats_charts", "ic_charts");
		menuItem("Reports", "admin.php?p=reports", "ic_reports", true);
		displayPluginItems($pluginItems,"stats");
		endMenu();
	}
	
	if (IsPrivilege(array("marketing", "all"), $auth_rights))
	{
		$topMenuButtons["menuMarketing"] = array("title"=>"Marketing<br>&nbsp;", "icon"=>"marketing", "alt"=>"Marketing");
		
		startMenu("menuMarketing");
		menuItem("Google", "admin.php?p=google_marketing", "ic_export");
		//menuItem("Altura Data Feed", "admin.php?p=export_altura", "ic_export");
		menuItem("Shopzilla Data Feed", "admin.php?p=export_shopzilla", "ic_export");
		menuItem("Sale Prices", "admin.php?p=sale_prices", "ic_expand");
		menuItem("iDevAffiliate Integration", "admin.php?p=affiliate", "ic_idev", true);
		menuItem("Doba Integration", "admin.php?p=doba", "ic_doba");
		menuItem("Cart Plug-ins", "admin.php?p=plugins", "ic_plugin", true);
		displayPluginItems($pluginItems,"marketing");
		endMenu();
	}