<?php
/**
 * Bulk products uploader
 */

	if (!defined("ENV")) exit();
	
	///////////////////////////////////////////
	// inherit basic niode & override drawNode
	class OPTION_PARAM{
		var $id;
		var $parent_id;
		var $level;
		function OPTION_PARAM($id, $parent_id, $level){
			$this->id = $id;
			$this->parent_id = $parent_id;
			$this->level = $level;
			return $this;
		}
	}
	$is_selected_cat = false;
	class OPTION_NODE extends DB_TREE_NODE{
		function drawNode($param){
			global $is_selected_cat;
			if($this->id!=$param->id){
				if($this->id != TREE_ROOT){
					//echo '<option value="'.$this->id.'" '.($this->id == $param->parent_id?"selected":"").' '.($this->is_visible=="No"?'style="color:gray;"':"").'>';
					echo '<option value="'.$this->id.'" '.($is_selected_cat==false?"selected":"").' '.($this->is_visible=="No"?'style="color:gray;"':"").'>';
					$is_selected_cat = true;
				}
				for($i=0; $i<($param->level-1)*4; $i++){
					echo "&nbsp;";
				}
				echo gs($this->caption).'</option>';
				if(count($this->nodes)>0){
					while(list($id, $node) = each($this->nodes)){
						$node->drawNode(
							new OPTION_PARAM($param->id, $param->parent_id, $param->level+1)
						);
					}
				}
			}
		}
	}

	//load categories
	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new OPTION_NODE(TREE_ROOT, -1, 0, "Yes", "Please Select a Category"));
	
	$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, priority, name");
	while (($category = $db->moveNext()) != false)
	{
		$tree->addNode(
			new OPTION_NODE(
				$category["cid"], 
				$category["parent"], 
				$category["level"], 
				$category["is_visible"],
				$category["name"]
			)
		);
	}
	
	// set fields for uploading
	//0 - caption
	//1 - default value
	//2 - required
	//3 - boolean
	$fields_names = array();
		
	
	$fields_names["skip"] = array("Skip", "", false, false);
	
	$fields_names["product_id"] = array("Product ID", "", true, false, array("productid", "id"));
	$fields_names["product_sku"] = array("Product SKU", "", true, false, array("productsku", "sku"));
	$fields_names["product_upc"] = array("UPC Code", "", true, false, array("upc", "productupc", "upccode"));
	$fields_names["title"] = array("Name", "", true, false, array("producttitle", "title", "productname", "name"));
	$fields_names["price"] = array("Price", "", true, false, array("productprice", "price", "itemprice"));
	
	$fields_names["cost"] = array("Cost", "0.00", false, false, array("productcost", "cost", "itemcost"));
	
	$fields_names["category"] = array("Category Keys", "", false, false, array("category", "categorykey"));
	$fields_names["manufacturer"] = array("Manufacturer ID", "0", false, false, array("manufacturer", "manufacturerid", "manufacturerkey"));
	$fields_names["location"] = array("Product Location", "0", false, false, array("location", "productlocation", "locationcode"));
		
	$fields_names["meta_keywords"] = array("Meta Keywords", "", false, false, array("metakeyword", "metakeywords", "keyword", "keywords"));
	$fields_names["meta_title"] = array("Meta Title", "", false, false, array("metatitle"));
	$fields_names["meta_description"] = array("Meta Description", "", false, false, array("metadescription"));
	$fields_names["priority"] = array("Sorting Priority", "0", false, false, array("productpriority", "priority", "sortorder"));
		
	$fields_names["call_for_price"] = array("Call For Price", "No", false, true, array("call", "callforprice"));
	$fields_names["is_taxable"] = array("Is Taxable", "Yes", false, true, array("istaxable", "taxable"));
	
	$fields_names["price2"] = array("Sale Price", "", false, false, array("saleprice", "sale"));
		
	$fields_names["price_level_1"] = array("Price Level 1", "0.00", false, false, array());
	$fields_names["price_level_2"] = array("Price Level 2", "0.00", false, false, array());
	$fields_names["price_level_3"] = array("Price Level 3", "0.00", false, false, array());
		
	//$fields_names["shipping_price"] = array("Shipping Price", "0.00", false, false);
	$db->query("SELECT * FROM ".DB_PREFIX."shipping_selected WHERE carrier_id='custom' AND method_id='product_level'");
	while (($shipping_selected = $db->moveNext()) != false)
	{
		$fields_names["shipping_price_".$shipping_selected["ssid"]] = array("Shipping Price - ".$shipping_selected["carrier_name"], "0.00", false, false, array());
	}
		
	$fields_names["free_shipping"] = array("Free Shipping", "No", false, true, array());
	$fields_names["weight"] = array("Unit Weight", "0", false, false, array());
		
	$fields_names["inter_pack"] = array("Inter Pack", "0", false, false, array());
	$fields_names["case_pack"] = array("Case Pack", "0", false, false, array());
		
	$fields_names["min_order"] = array("Min Order", "1", false, false, array());
	$fields_names["max_order"] = array("Max Order", "0", false, false, array());
		
	$fields_names["is_visible"] = array("Available", "Yes", false, true, array());
	$fields_names["is_home"] = array("On Home Page", "Yes", false, true, array());
	$fields_names["is_hotdeal"] = array("Is Hotdeal", "Yes", false, true, array());

		
	$fields_names["digital_product"] = array("Is Digital Product", "No", false, true, array());
	$fields_names["digital_product_file"] = array("Digital Product File", "", false, false, array());
		
	if(_ACCESS_ALL || _ACCESS_INVENTORY){
		$fields_names["inventory_control"] = array("Track Inventory", "No", false, true, array());
		$fields_names["stock"] = array("Stock", "0", false, false, array());
		$fields_names["stock_warning"] = array("Stock Warning", "0", false, false, array());
		$fields_names["inventory_rule"] = array("Inventory Rule", "Hide", false, false, array()); //'Hide', 'OutOfStock'
	}
	
	$fields_names["overview"] = array("Overview", "", false, false, array());
	$fields_names["description"] = array("Description", "", false, false, array());
		
	$fields_names["image_url"] = array("Image URL", "", false, false, array());
	
	if(_ACCESS_ALL || _ACCESS_ATTRIBUTES){
		$fields_names["attribute_name_1"] = array("Attribute Name 1", "", false, false, array());
		$fields_names["attribute_caption_1"] = array("Attribute Caption 1", "", false, false, array());
		$fields_names["attribute_options_1"] = array("Attribute Options 1", "", false, false, array());
		
		$fields_names["attribute_name_2"] = array("Attribute Name 2", "", false, false, array());
		$fields_names["attribute_caption_2"] = array("Attribute Caption 2", "", false, false, array());
		$fields_names["attribute_options_2"] = array("Attribute Options 2", "", false, false, array());

		$fields_names["attribute_name_3"] = array("Attribute Name 3", "", false, false, array());
		$fields_names["attribute_caption_3"] = array("Attribute Caption 3", "", false, false, array());
		$fields_names["attribute_options_3"] = array("Attribute Options 3", "", false, false, array());
	}
	
	////////////////////////////////////////////
	$bool_true = array("true", "yes", "1", "ok", "on");
	$bool_false = array("false", "no", "0", "not", "off");
	
	$attribute_fields = array(
		"attribute_name_1",
		"attribute_caption_1",
		"attribute_options_1",
		"attribute_name_2",
		"attribute_caption_2",
		"attribute_options_2",
		"attribute_name_3",
		"attribute_caption_3",
		"attribute_options_3",
	);
?>