<?php
/**
 * Bulk uploader step 1
 */

	if (!defined("ENV")) exit();

	// products bulk uploader - step 1
	pageNote(array(
		array("icon"=>"ic_hint.gif", "text"=>"This section will allow you to upload product data into your shopping cart from a .CSV file only. Most database programs (including Excel) will allow you to import or save data in this format. The data must have a delimiter (comma or semicolon) and each line must contain data specific to the product. Once uploaded, ".$label_app_name." will ask you which column represents what data type (Product ID, Product Name, Price, etc). ".$label_app_name." uses Product ID as a data key and any product with a duplicate ID will be overwritten with the new data. This is a 3 step process and the data will not be stored until the final step is complete", "url"=>"", "visible"=>true),
		array("icon"=>"ic_hint.gif", "text"=>"<b>Please note: Products with undefined weight and shipping price will be automatically marked as Free Shipping</b>", "url"=>"", "visible"=>true),
		array("icon"=>"ic_hint.gif", "text"=>"<b>Please fill this form very carefully!</b>", "url"=>"", "visible"=>true),
	));
	pageTabs(array(
		array("title"=>"Bulk Uploading - Step 1", "id"=>"Main", "active"=>true, "width"=>140),
	));
?>
<form action="admin.php?p=bulk_products" method="post" name="frmBulk" id="frmBulk" enctype="multipart/form-data">
	<input type="hidden" name="step" value="2">
<div id="idTabSheetMain" class="sheetActive" style="padding:0px;margin:0px;">
	<table width="100%" cellpadding="0" cellspacing="5" border="0">
		<tr>
			<td class="formHeader" colspan="2">
				<div class="formHeaderIcon"><img src="images/icons/ic_open_folder.gif"></div>
				<div class="formHeaderText">Uploading Settings</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption"><b>Select default category</b></td>
			<td class="formItemControl">
				<select name="cid" style="width:100%;" size="10">
<?	$tree->collection[TREE_ROOT]->drawNode(
		new OPTION_PARAM(-1, TREE_ROOT, 0)
	);?>
				</select>
				<div class="formItemComment">Products with undefined category will be moved in selected category</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Delimeter used to separate the data</td>
			<td class="formItemControl">
				<select name="fields_separator" style="width:250px;">
					<option value=",">Comma (,)</option>
					<option value=";">Semicolon (;)</option>
				</select>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Data update rule</td>
			<td class="formItemControl">
				<select name="update_rule" style="width:250px;">
					<option value="overwrite">Overwrite existing data - Add New</option>
					<option value="keep">Keep existing data - Add New</option>
					<option value="clean">Clear existing data - Add New</option>
					<option value="update_only">Update existing products only</option>
				</select>
				<div class="formItemComment">
					If the bulk loader encounters a duplicate Product ID, should it
					overwrite the existing data with the bulk loaded data, keep it,
					or clear all products from selected category first?
				</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Uploaded products availability</td>
			<td class="formItemControl">
				<select name="make_products_visible" style="width:250px;">
					<option value="Yes">Products are available for sale</option>
					<option value="No">Products are not available for sale</option>
				</select>
				<div class="formItemComment">
					Depending on your choice, the bulk loader will set a Product Availability option.
					You may also set this option in the uploaded file.
				</span>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption"><b>Choose CSV file from local drive</b></td>
			<td class="formItemControl"><input type="file" name="bulk" style="width:250px;"></td>
		</tr>
	</table>
</div>
<div class="formButtons">
	<input type="image" src="images/admin/bt_upload_file.gif"> &nbsp;
	<input type="image" src="images/admin/bt_reset_form.gif" onClick="frmBulk.reset();return false;">
</div>
</form>