<?php

	if (!defined("ENV")) exit();

	$action = isset($action)?trim($action):"";
	if($action == "update_discounts" && !DEMO_LOCK){
		$min_values = isset($min_values)?(is_array($min_values)?$min_values:array()):array();
		$max_values = isset($max_values)?(is_array($max_values)?$max_values:array()):array();
		$discounts = isset($discounts)?(is_array($discounts)?$discounts:array()):array();
		$types = isset($types)?(is_array($types)?$types:array()):array();
		$active = isset($active)?(is_array($active)?$active:array()):array();
		reset($min_values);
		foreach($min_values as $id=>$min){
			$db->reset();
			$db->assignStr("min", normalizeNumber($min_values[$id]));
			$db->assignStr("max", normalizeNumber($max_values[$id]));
			$db->assignStr("discount", normalizeNumber($discounts[$id]));
			$db->assignStr("type", $types[$id]);
			$db->assignStr("active", array_key_exists($id, $active)?"Yes":"No");
			$db->update(DB_PREFIX."discounts", "WHERE did='".$id."'");
		}
		$use_discounts = isset($use_discounts)?trim($use_discounts):"YES";
		$db->reset();
		$db->assignStr("value", $DiscountsActive);
		$db->update(DB_PREFIX."settings", "WHERE name='DiscountsActive'");
		$settings["DiscountsActive"] = $DiscountsActive;
	}
	
	//pageHeader("Promo Codes", "", "");
	
	$from_y = isset($from_y)?$from_y:date("Y");
	$from_m = isset($from_m)?$from_m:date("n");
	$from_d = isset($from_d)?$from_d:1;
	$to_y = isset($to_y)?$to_y:date("Y");	
	$to_m = isset($to_m)?$to_m:date("n");
	$to_d = isset($to_d)?$to_d:date("t", mktime(1,1,1,$to_m, 1, $to_y));
	
	$action = empty($action)?"":$action;
	if($action == "insert_promo" && !DEMO_LOCK){
		$mysql_from =  $from_y."-".$from_m."-".$from_d;
		$mysql_to =  $to_y."-".$to_m."-".$to_d;
		$db->reset();
		$db->assignStr("name", $name);
		$db->assignStr("promo_code", $promo_code);
		$db->assignStr("date_start", $mysql_from);
		$db->assignStr("date_stop", $mysql_to);
		$db->assignStr("is_active", $is_active);
		$db->assignStr("is_global", $is_global);
		$db->assignStr("min_amount", $min_amount);
		$db->assignStr("discount", $discount);
		$db->assignStr("discount_type", $discount_type);
		$db->insert(DB_PREFIX."promo_codes");
		$pid = $db->insertId();
		$db->query("DELETE FROM ".DB_PREFIX."promo_products WHERE pid='".$pid."'");
		$db->query("DELETE FROM ".DB_PREFIX."promo_categories WHERE pid='".$pid."'");
		
		if($is_global != "Yes")
			header("Location: admin.php?p=promo_edit&q=" . urlencode($pid));
	}
	if($action == "delete_promo" && !DEMO_LOCK){
		$db->query("DELETE FROM ".DB_PREFIX."promo_codes WHERE pid='".$pid."'");
		$db->query("DELETE FROM ".DB_PREFIX."promo_products WHERE pid='".$pid."'");
		$db->query("DELETE FROM ".DB_PREFIX."promo_categories WHERE pid='".$pid."'");
	}
	if($action == "update_promo" && !DEMO_LOCK){
		$db->query("UPDATE ".DB_PREFIX."promo_codes SET is_active='No'");
		$is_active = empty($is_active)?array():$is_active;
		foreach($is_active as $id=>$v){
			$db->query("UPDATE ".DB_PREFIX."promo_codes SET is_active='Yes' WHERE pid='".$id."'");
		}
		$db->reset();
		$db->assignStr("value", $DiscountsPromo);
		$db->update(DB_PREFIX."settings", "WHERE name='DiscountsPromo'");
		$settings["DiscountsPromo"] = $DiscountsPromo;
	}
	
	
	loadJS("cf_promo.js");
	loadJS("cf_discounts.js");
	loadJS("cd_promo.js");
	
	pageHeader("Discounts", "", "ic_discount.gif");
	pageNote(array(
		array("icon"=>"ic_hint.gif", "text"=>"The discounts you set on this page are global for the cart and will be applied to all purchases.<br/>To set individual discounts, go to \"Add a Product\" page and enter the specific discount on a product.<br/>You can choose to use a range of discounts as a flat rate or percentage.<br/>Ideally, the range is used as an incentive to get larger purchases.", "url"=>"", "visible"=>true),
		array("icon"=>"ic_hint.gif", "text"=>"Please note: Enter numbers with . (dot) decimal symbol", "url"=>"", "visible"=>true)
	));
	$last_active_tab = isset($last_active_tab)?trim($last_active_tab):"idTabGlobal";
	pageTabs(array(
		array("title"=>"Global Discounts", "id"=>"Global", "active"=>$last_active_tab == "idTabGlobal", "width"=>120),
		array("title"=>"Promo Codes", "id"=>"Promo", "active"=>$last_active_tab == "idTabPromo", "width"=>120, "visible"=>true),
	));
?>
<!-- START GLOBAL DISCOUNTS -->
<div id="idTabSheetGlobal" class="<?=$last_active_tab == "idTabGlobal"?"sheetActive":"sheetUnactive"?>">
<form name="frmDiscounts" action="admin.php?p=discounts" method="post" onSubmit="return CheckDiscountsForm(this)">
	<input type="hidden" name="action" value="update_discounts">
<table width="100%" cellpadding="0" cellspacing="5" border="0">
	<tr>
		<td class="formHeader" colspan="2">
			<div class="formHeaderIcon"><img src="images/icons/ic_discount.gif"/></div>
			<div class="formHeaderText">Global Discounts</div>
		</td>
	</tr>
	<tr>
		<td class="formItemCaption">Use Global Discounts?</td>
		<td class="formItemControl">
			<select name="DiscountsActive" style="width:123px;">
				<option value="YES">Yes</option>
				<option value="NO" <?=$settings["DiscountsActive"]=="NO"?"selected":""?>>No</option>
			</select>
		</td>
	</tr>
</table>
<table width="100%" cellpadding="5" cellspacing="0" border="0">
	<tr>
		<td class="formListHeaderIcon">&nbsp;</td>
		<td class="formListHeaderCaption" style="width:115px;">&nbsp;</td>
		<td class="formListHeaderCaption" style="width:115px;">Min Amount</td>
		<td class="formListHeaderCaption" style="width:115px;">Max Amount</td>
		<td class="formListHeaderCaption" style="width:115px;">Discount</td>
		<td class="formListHeaderCaption">&nbsp;</td>
	</tr>
	<tr><td colspan="6" height="5"></td></tr>
<?
	$db->query("SELECT * FROM ".DB_PREFIX."discounts ORDER BY did");
	$i = 1;
	while($db->moveNext()){
?>
	<tr valign="top">
		<td class="formListItemIcon"><input id="id_active<?=$i?>" type="checkbox" name="active[<?=$db->col["did"]?>]" value="Yes" <?=$db->col["active"]=="Yes"?"checked":""?>></td>
		<td class="formListItemText"><label for="id_active<?=$i?>">Range <?=$i++?></label></td>
		<td class="formListItemText"><input type="text" name="min_values[<?=$db->col["did"]?>]" value="<?=myNum($db->col["min"])?>" style="width:100px;"></td>
		<td class="formListItemText"><input type="text" name="max_values[<?=$db->col["did"]?>]" value="<?=myNum($db->col["max"])?>" style="width:100px;"></td>
		<td class="formListItemText"><input type="text" name="discounts[<?=$db->col["did"]?>]" value="<?=myNum($db->col["discount"])?>" style="width:100px;"></td>
		<td class="formListItemText">
			<select name="types[<?=$db->col["did"]?>]">
				<option value="percent">%</option>
				<option value="amount" <?=$db->col["type"]=="amount"?"selected":""?>><?=$admin_currency["code"]?></option>
			</select>
		</td>
	</tr>
<?	}?>

	<tr>
		<td colspan="6" class="formButtons">
			<input type="image" src="images/admin/bt_save_changes.gif"> &nbsp;
			<input type="image" onClick="frmDiscounts.reset();return false;" src="images/admin/bt_reset_form.gif">
		</td>
	</tr>
</form>
</table>
</div>
<!--- START PROMO CODES      --->
<div id="idTabSheetPromo" class="<?=$last_active_tab == "idTabPromo"?"sheetActive":"sheetUnactive"?>">
<?php
	$db->query("
		SELECT *, 
			DATE_FORMAT(date_start, '%m/%d/%Y') AS date1,
			DATE_FORMAT(date_stop, '%m/%d/%Y') AS date2
		FROM ".DB_PREFIX."promo_codes ORDER BY pid");
	if($db->numRows() < 1){
?>
<table width="100%" cellpadding="0" cellspacing="5" border="0">
	<tr>
		<td class="formHeader" colspan="2">
			<div class="formHeaderIcon"><img src="images/icons/ic_discount.gif"/></div>
			<div class="formHeaderText">Promo Codes</div>
		</td>
	</tr>
	
</table>
<?
		pageNote(array(
			array("icon"=>"ic_hint.gif", "text"=>"<b><span style=\"color:#990000\">There are currently no promo codes.</span></b>", "url"=>"", "visible"=>true)
		));
	}
	else{
?>
<table width="100%" cellpadding="0" cellspacing="5" border="0">
<form name="frmTaxes" action="admin.php?p=discounts#promo" method="post">
	<input type="hidden" name="action" value="update_promo">
	<tr>
		<td colspan="2" class="formHeader">
			<div class="formHeaderIcon"><img src="images/icons/ic_expand.gif"/></div>
			<div class="formHeaderText">Promo Codes<a name="promo"></div>
		</td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption">Do you want to enable promo codes?</td>
		<td class="formItemControl">
			<select name="DiscountsPromo" style="width:123px;">
				<option value="YES">Yes</option>
				<option value="NO" <?=$settings["DiscountsPromo"]=="NO"?"selected":""?>>No</option>
			</select>
		</td>
	</tr>
</table>
<table width="100%" cellpadding="5" cellspacing="0" border="0">
	<tr>
		<td class="formListHeaderIcon">&nbsp;</td>
		<td class="formListHeaderCaption" width="15%">Campaign Name</td>
		<td class="formListHeaderCaption" width="20%">Date Ranges</td>
		<td class="formListHeaderCaption" width="10%">Promo Code</td>
		<td class="formListHeaderCaption" width="15%">Is this a global or product-based promo?</td>
		<td class="formListHeaderCaption" width="10%">Discount</td>
		<td class="formListHeaderCaption" width="10%">Subtotal</td>
		<td class="formListHeaderCaption">&nbsp;</td>
	</tr>
<?	while($db->moveNext()){?>
	<tr>
		<td class="formListItemIcon">
			<input id="sdf_<?=$db->col["pid"]?>" type="checkbox" name="is_active[<?=$db->col["pid"]?>]" value="Yes" <?=$db->col["is_active"]=="Yes"?"checked":""?>>
		</td>
		<td class="formListItemText"><label for="sdf_<?=$db->col["pid"]?>"><?=gs($db->col["name"])?></label></td>
		<td class="formListItemText"><?=gs($db->col["date1"])?> - <?=gs($db->col["date2"])?></td>
		<td class="formListItemText"><?=gs($db->col["promo_code"])?></td>
		<td class="formListItemText"><?=$db->col["is_global"] == "Yes" ? "Global Promo" : "Product-based Promo"?></td>
		<td class="formListItemText"><?=$db->col["discount_type"]=="amount"?getAdminPrice($db->col["discount"]):(number_format($db->col["discount"],2)." %")?></td>
		<td class="formListItemText"><?=getAdminPrice($db->col["min_amount"])?></td>
		<td class="formListItemButtons">
		<?php
			if($db->col["is_global"] != "Yes") // In case of typo -- Ricky26
			{
				echo '<a href="admin.php?p=promo_edit&q=' . $db->col["pid"] . '"><img src="images/icons/ic_settings.gif" alt="Edit" border="0"></a>';
			} 
		?>
			<a href="javascript:ConfirmDeletePromo(<?=$db->col["pid"]?>)"><img src="images/icons/ic_delete.gif" border="0"></a>
		</td>
	</tr>
<?	}?>

	<tr>
		<td colspan="7" class="formButtons">
			<input type="image" src="images/admin/bt_save_changes.gif"> &nbsp;
			<input type="image" src="images/admin/bt_reset_form.gif" onClick="frmTaxes.reset();return false;">
		</td>
	</tr>
</form>
</table>

&nbsp;
<?
	}
?>
<div style="clear:both;">
<table width="100%" cellpadding="0" cellspacing="5" border="0">
<form name="frmPromo" action="admin.php?p=discounts#promo" method="post" onsubmit="return CheckPromoForm(this)" enctype="multipart/form-data">
	<input type="hidden" name="action" value="insert_promo">
	<tr>
		<td colspan="2" class="formHeader">
			<div class="formHeaderIcon"><img src="images/icons/ic_insert_row.gif"/></div>
			<div class="formHeaderText">Create a New Promo Code</div>
		</td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption"><b>Campaign Name</b></td>
		<td class="formItemControl">
			<input style="width:250px;" type="text" name="name" maxlength="250"><br>
		</td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption"><b>Promo Code</b></td>
		<td class="formItemControl"><input style="width:250px;" type="text" name="promo_code" maxlength="250"></td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption"><b>Is it Active?</b></td>
		<td class="formItemControl">
			<select name="is_active" style="width:123px;">
				<option value="Yes">Yes</option>
				<option value="No">No</option>
			</select>
		</td>
	</tr>
	<tr>
		<td class="formItemCaption"><b>Is it a global or product-based promotion?</b></td>
		<td class="formItemControl">
			<select name="is_global" style="width:123px;">
				<option value="Yes">Global</option>
				<option value="No">Product-based</option>
			</select>
		</td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption">Start Date</td>
		<td class="formItemControl">
			<select name="from_m" style="width:123px;">
<?		for($i=1; $i<=12; $i++){?>
				<option value="<?=$i?>" <?=$i == $from_m?"selected":""?>><?=$months[$i]?></option>
<?		}?>		</select>
			<select name="from_d" style="width:123px;">
<?				for($i=1; $i<=31; $i++){?>
				<option value="<?=$i?>" <?=$i == $from_d?"selected":""?>><?=$i?></option>
<?				}?>
			</select>
			<select name="from_y" style="width:123px;">
<?				for($i=2003; $i<=date("Y")+10; $i++){?>
				<option value="<?=$i?>" <?=$i == $from_y?"selected":""?>><?=$i?></option>
<?				}?>
			</select>
		</td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption">End Date</td>
		<td class="formItemControl">
			<select name="to_m" style="width:123px;">
<?		for($i=1; $i<=12; $i++){?>
				<option value="<?=$i?>" <?=$i == $to_m?"selected":""?>><?=$months[$i]?></option>
<?		}?>		</select>
			<select name="to_d" style="width:123px;">
<?		for($i=1; $i<=31; $i++){?>
				<option value="<?=$i?>" <?=$i == $to_d?"selected":""?>><?=$i?></option>
<?		}?>
			</select>
			<select name="to_y" style="width:123px;">
<?		for($i=2003; $i<=date("Y")+10; $i++){?>
				<option value="<?=$i?>" <?=$i == $to_y?"selected":""?>><?=$i?></option>
<?		}?>
			</select>
		</td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption"><b>Discount</b></td>
		<td class="formItemControl">
			<input style="width:123px;" type="text" name="discount">
			<select name="discount_type">
				<option value="amount"><?=$admin_currency["code"]?></option>
				<option value="percent">%</option>
			</select>
		</td>
	</tr>
	<tr valign="top">
		<td class="formItemCaption"><b>Minimum order subtotal for this code</b></td>
		<td class="formItemControl"><input style="width:123px;" type="text" name="min_amount"></td>
	</tr>
	<tr>
		<td colspan="2" class="formButtons">
			<input type="image" src="images/admin/bt_save_changes.gif" default> &nbsp;
			<input type="image" onClick="frmPromo.reset();return false;" src="images/admin/bt_reset_form.gif">
		</td>
	</tr>
	</form>
</table>
</div>
</div>