<?php
	if (!defined("ENV")) exit();

	require_once("content/classes/class.regions.php");
	require_once("content/classes/class.taxes.php");
	require_once("content/classes/class.products_locations.php");

	if($iono->max_product_count > 0){
		$db->query("SELECT COUNT(*) AS c FROM ".DB_PREFIX."products");
		$db->moveNext();
		$products_count = $db->col["c"];
	}
	else{
		$products_count = -1;
	}

	$taxes = new Taxes($db);

	$productsLocations = new ProductsLocations($db);

	$last_active_tab = isset($last_active_tab) ? $last_active_tab : "idTabCat";

	$categories = array();
	$prev_pid = false;
	$next_pid = false;
	$google_co_active = false;
	//Check if google checkout is enaled
	$db->query("SELECT active FROM ".DB_PREFIX."payment_methods WHERE id='googlecheckout'");
	if($db->moveNext()){
		if($db->col["active"] =="Yes"){
			$google_co_active = true;
		}
	}

	///////////////////////////////////////////
	// inherit basic niode & override drawNode
	class OPTION_PARAM{
		var $parent_id;
		var $level;
		var $categories;
		function OPTION_PARAM($parent_id, $level, $categories = array()){
			$this->parent_id = $parent_id;
			$this->level = $level;
			$this->categories = $categories;
			return $this;
		}
	}

	class OPTION_NODE extends DB_TREE_NODE{
		function drawNode($param){
			if($this->id != TREE_ROOT){
				echo '<option value="'.$this->id.'" '.(($this->id == $param->parent_id || in_array($this->id, $param->categories))?"selected":"").' '.($this->is_visible=="No"?'style="color:gray;"':"").'>';
				for($i=0; $i<$param->level*4; $i++){
					echo "&nbsp;";
				}
				echo htmlspecialchars($this->caption).'</option>';
			}
			if(count($this->nodes)>0){
				reset($this->nodes);
				while(list($id, $node) = each($this->nodes)){
					$node->drawNode(
						new OPTION_PARAM($param->parent_id, $param->level+1, $param->categories)
					);
				}
			}
		}
	}

	$tree = new DB_TREE();
	$tree->collection[TREE_ROOT] = (new OPTION_NODE(TREE_ROOT, -1, 0, "Yes",  "None selected"));

	$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, priority, name");
	$cats_count = $db->numRows();
	while($db->moveNext()){
		$tree->addNode(
			new OPTION_NODE(
				$db->col["cid"],
				$db->col["parent"],
				$db->col["level"],
				$db->col["is_visible"],
				$db->col["name"]
			)
		);
	}

	$mode = isset($mode)?trim($mode):"insert";
	$mode = in_array($mode, array("insert", "update")) ? $mode : "insert";
	if(count($tree->collection) > 1 && ($mode != "insert" || ($iono->max_product_count > $products_count && $mode == "insert"))){
		$pid = isset($pid)?$pid*1:"";

		switch($mode){
			case "update" : {
				$db->query("SELECT gift_max_quantity FROM ".DB_PREFIX."products_gifts WHERE pid='".$pid."'");
				if($db->moveNext()){
					$gift_max_quantity = $db->col["gift_max_quantity"];
					$gift_max_quantity=isset($gift_max_quantity)?$gift_max_quantity*1:"";
				}else	$gift_max_quantity = 999;

				$db->query("SELECT * FROM ".DB_PREFIX."products WHERE pid='".$pid."'");

				if($db->moveNext()){
					$cid = $db->col["cid"];
					$is_visible = $db->col["is_visible"];
					$is_hotdeal = $db->col["is_hotdeal"];
					$is_home = $db->col["is_home"];
					$is_google_co = $db->col["is_google_co"];
					$is_taxable = $db->col["is_taxable"];
					$is_dollar_days = $db->col["is_dollar_days"];
					$is_doba = $db->col["is_doba"];
					$is_locked = $db->col["is_locked"];
					$inventory_control  = $db->col["inventory_control"];
					$inventory_rule  = $db->col["inventory_rule"];
					$stock = $db->col["stock"];
					$stock_warning = $db->col["stock_warning"];
					$weight = $db->col["weight"];
					$free_shipping = $db->col["free_shipping"];
					$digital_product = $db->col["digital_product"];
					$digital_product_file = $db->col["digital_product_file"];
					$cost = $db->col["cost"];
					
					
					// 2010-07-12 pkolas
					$size = $db->col['size'];
					$year = $db->col['year'];
					$condition1 = $db->col['condition1'];
					$equipment_type = $db->col['equipment_type'];
					$pdf_name = $db->col['pdf_name'];
					$video_title = $db->col['video_title'];
					$video_file = $db->col['video_file'];
					$video_cover = $db->col['video_cover'];
					// 2010-07-12 pkolas end
					
					
					if($db->col["price2"]>0){
						$price = $db->col["price2"];
						$price2 = $db->col["price"];
					}
					else{
						$price = $db->col["price"];
						$price2 = "";
					}
					$call_for_price = $db->col["call_for_price"];
					$price_level_1 = $db->col["price_level_1"];
					$price_level_2 = $db->col["price_level_2"];
					$price_level_3 = $db->col["price_level_3"];
					$tax_rate = $db->col["tax_rate"];
					$tax_class_id = $db->col["tax_class_id"];
					$min_order = $db->col["min_order"];
					$max_order = $db->col["max_order"];
					$product_id = $db->col["product_id"];
					$product_sku = $db->col["product_sku"];
					$product_upc = $db->col["product_upc"];
					$case_pack = $db->col["case_pack"];
					$inter_pack = $db->col["inter_pack"];
					$gift_quantity = $db->col["gift_quantity"];

					$title = $db->col["title"];
					$meta_keywords = $db->col["meta_keywords"];
					$meta_title = $db->col["meta_title"];
					$meta_description = $db->col["meta_description"];
					$url_default = $db->col["url_default"];
					$url_custom = $db->col["url_custom"];
					$manufacturer_id = $db->col["manufacturer_id"];
					$overview = $db->col["overview"];
					$description = $db->col["description"];
					$dimension_width = $db->col["dimension_width"];
					$dimension_length = $db->col["dimension_length"];
					$dimension_height = $db->col["dimension_height"];
					$priority = $db->col["priority"];
					$image_location = $db->col["image_location"];
					$image_url = $db->col["image_url"];
					$image_alt_text = $db->col["image_alt_text"];
					$zoom_option = $db->col["zoom_option"];

					$products_location_id = $db->col["products_location_id"];

					//////////////////////////////
					$db->query("SELECT * FROM ".DB_PREFIX."products WHERE product_id LIKE '".$db->escape($product_id)."' AND pid<>'".$pid."'");
					if($db->moveNext()){
						$dw = true;
					}
					$db->query("SELECT * FROM ".DB_PREFIX."products_categories WHERE pid='".$pid."' AND is_primary=0");
					while($db->moveNext()){
						if($db->col["cid"] != $cid){
							$categories[] = $db->col["cid"];
						}
					}
					$db->query("SELECT MAX(pid) AS c FROM ".DB_PREFIX."products WHERE pid<'".$pid."'");
					$db->moveNext();
					$prev_pid = $db->col["c"];
					$db->query("SELECT MIN(pid) AS c FROM ".DB_PREFIX."products WHERE pid>'".$pid."'");
					$db->moveNext();
					$next_pid = $db->col["c"];
					break;
				}
			}
			default :
			case "insert" : {
				if($pid > 0 && $mode != "update"){
					$db->query("SELECT gift_max_quantity FROM ".DB_PREFIX."products_gifts WHERE pid='".$pid."'");
					if($db->moveNext()){
						$gift_max_quantity = $db->col["gift_max_quantity"];
					}else	$gift_max_quantity = 999;
					$gift_max_quantity = " ";

					$db->query("SELECT * FROM ".DB_PREFIX."products WHERE pid='".$pid."'");
					if($db->moveNext()){
						$cid = $db->col["cid"];
						$is_visible = $db->col["is_visible"];
						$is_hotdeal = $db->col["is_hotdeal"];
						$is_home = $db->col["is_home"];
						$is_google_co = $db->col["is_google_co"];
						$is_taxable = $db->col["is_taxable"];
						$is_dollar_days = "No";
						$is_doba = "No";
						$is_locked = "No";
						$inventory_control  = $db->col["inventory_control"];
						$inventory_rule  = $db->col["inventory_rule"];
						$stock = $db->col["stock"];
						$stock_warning = $db->col["stock_warning"];
						$weight = $db->col["weight"];
						$free_shipping = $db->col["free_shipping"];
						$digital_product = $db->col["digital_product"];
						$digital_product_file = $db->col["digital_product_file"];
						
						
						// 2010-07-12 pkolas
						$size = '';
						$year = '';
						$condition1 = '';
						$equipment_type = '';
						$pdf_name = '';
						$video_title = '';
						$video_file = '';
						$video_cover = '';
						// 2010-07-12 pkolas end
						
						
						if($db->col["price2"]>0){
							$price = $db->col["price2"];
							$price2 = $db->col["price"];
						}
						else{
							$price = $db->col["price"];
							$price2 = "";
						}
						$call_for_price = $db->col["call_for_price"];
						$price_level_1 = $db->col["price_level_1"];
						$price_level_2 = $db->col["price_level_2"];
						$price_level_3 = $db->col["price_level_3"];
						$tax_rate = $db->col["tax_rate"];
						$tax_class_id = $db->col["tax_class_id"];
						$min_order = $db->col["min_order"];
						$max_order = $db->col["max_order"];
						$url_default = "will be generated after product saved";
						$url_custom = "";
						$product_id = "";
						$product_sku = "";
						$product_upc = "";
						$case_pack = $db->col["case_pack"];
						$inter_pack = $db->col["inter_pack"];
						$gift_quantity = $db->col["gift_quantity"];

						$title = $db->col["title"];
						$meta_keywords = $db->col["meta_keywords"];
						$meta_title = $db->col["meta_title"];
						$meta_description = $db->col["meta_description"];
						$manufacturer_id = $db->col["manufacturer_id"];
						$overview = $db->col["overview"];
						$description = $db->col["description"];
						$dimension_width = $db->col["dimension_width"];
						$dimension_length = $db->col["dimension_length"];
						$dimension_height = $db->col["dimension_height"];
						$priority = $db->col["priority"];
						$image_location = $db->col["image_location"];
						$image_url = $db->col["image_url"];
						$image_alt_text = $db->col["image_alt_text"];
						$zoom_option = $db->col["zoom_option"];

						$products_location_id = $db->col["products_location_id"];

						$db->query("SELECT * FROM ".DB_PREFIX."products_categories WHERE pid='".$pid."' AND is_primary=0");
						while($db->moveNext()){
							$categories[] = $db->col["cid"];
						}
					}
				}
				else{
					$mode = "insert";
					$cid = isset($cid)?$cid*1:TREE_ROOT;
					$is_visible = "Yes";
					$is_hotdeal = "No";
					$is_home = "No";
					$is_google_co = "Yes";
					$is_taxable = "Yes";
					$is_dollar_days = "No";
					$is_doba = "No";
					$is_locked = "No";
					$inventory_control = "No";
					$inventory_rule  = "Hide";
					$stock = 0;
					$stock_warning = 0;
					$weight = "0.00";
					$free_shipping = "No";
					//$shipping_price = "0.00";
					$digital_product = "No";
					$digital_product_file = "";
					$cost = "";
					
					
					// 2010-07-12 pkolas
					$size = '';
					$year = '';
					$condition1 = '';
					$equipment_type = '';
					$pdf_name = '';
					$video_title = '';
					$video_file = '';
					$video_cover = '';
					// 2010-07-12 pkolas end
					
					
					$price = "";
					$price2 = "";
					$call_for_price = "No";
					$price_level_1 = 0;
					$price_level_2 = 0;
					$price_level_3 = 0;
					$tax_rate = 0;
					$tax_class_id = 1;  //Add all products to default tax class
					$min_order = 1;
					$max_order = 0;
					$product_id = "";
					$product_sku = "";
					$product_upc = "";
					$case_pack = -1;
					$inter_pack = -1;
					$gift_quantity = 1;
					$gift_max_quantity = 999;
					$title = "";
					$meta_keywords = "";
					$meta_title = "";
					$meta_description = "";
					$url_default = "will be generated after product saved";
					$url_custom = "";
					$manufacturer_id = 0;
					$overview = "";
					$description = "";
					$dimension_width = 0;
					$dimension_length = 0;
					$dimension_height = 0;
					$priority = 0;
					$image_location = "Local";
					$image_url = "";
					$image_alt_text = "";
					$zoom_option = "";
					$products_location_id = 0;
				}
				$pid = 0;
			}
		}

		$stock = $stock < 0 ? 0 : $stock;
?>
<script type="text/javascript" src="content/vendors/jquery/ddaccordion/ddaccordion.js"></script>
<script type="text/javascript">
ddaccordion.init({
	headerclass:"sliderButton", //Shared CSS class name of headers group
	contentclass:"sliderDiv", //Shared CSS class name of contents group
	collapseprev:false, //Collapse previous content (so only one open at any time)? true/false
	defaultexpanded:[], //index of content(s) open by default [index1, index2, etc]. [] denotes no content.
	animatedefault:false, //Should contents open by default be animated into view?
	persiststate:true, //persist state of opened contents within browser session?
	toggleclass:["", ""], //Two CSS classes to be applied to the header when it's collapsed and expanded, respectively ["class1", "class2"]
	togglehtml:["src", "images/icons/ic_arrow_down.gif", "images/icons/ic_arrow_up.gif"], //Additional HTML added to the header when it's collapsed and expanded, respectively  ["position", "html1", "html2"] (see docs)
	animatespeed:"fast" //speed of animation: "fast", "normal", or "slow"
})
</script>
<?
		loadJS("cf_product.js");
		loadJS("cd_product.js");
		loadJS("product_gifts.js");

		pageHeader("Product", ucfirst(strtolower($mode)), "ic_product_".($mode == "update" ? "edit" : "add").".gif");


		pageNote(array(
			array("icon"=>"ic_hint.gif", "text"=>"<b>Please note : required fields are bold</b>", "url"=>"",  "visible"=>true),
			array("icon"=>"ic_hint.gif", "text"=>"Decimal points and commas are accepted in the Product Price and Weight fields.", "url"=>"",  "visible"=>true),
			array("icon"=>"ic_delete.gif", "text"=>"Delete this product", "url"=>"JavaScript:ConfirmDeleteProduct('".$pid."')",  "visible"=>$mode=="update"),
			//array("icon"=>"", "text"=>"&nbsp;", "url"=>"",  "visible"=>$mode=="insert"),
			array("icon"=>"ic_hint.gif", "text"=>"<span style=\"color:#990000\"><b>Please note: There are currently no product categories in database.</b><br>Please add product categories first</span>", "url"=>"", "visible"=>$cats_count < 1),
			array("icon"=>"ic_dollar.gif", "text"=>"Product source: DollarDays.com", "url"=>"",  "visible"=>$is_dollar_days == "Yes"),
			array("icon"=>"ic_doba.gif", "text"=>"Product source: Doba.com", "url"=>"",  "visible"=>$is_doba == "Yes"),
		));

		pageTabs(array(
			array("title"=>"Product Info", "id"=>"Cat", "active"=>$last_active_tab == "idTabCat", "width"=>60),
			array("title"=>"Attributes", "id"=>"Attr", "active"=>$last_active_tab == "idTabAttr", "width"=>50, "visible"=>true),
			array("title"=>"Inventory", "id"=>"Inventory", "active"=>$last_active_tab == "idTabInventory", "width"=>50, "visible"=>true),
			array("title"=>"Recommended", "id"=>"Families", "active"=>$last_active_tab == "idTabFamilies", "width"=>70, "visible"=>true),
			array("title"=>"Product Promotions", "id"=>"Gifts", "active"=>$last_active_tab == "idTabGifts", "width"=>100, "visible"=>true),
			array("title"=>"Quantity Discounts", "id"=>"Discounts", "active"=>$last_active_tab == "idTabDiscounts", "width"=>93, "visible"=>true),
			array("title"=>"Secondary Images", "id"=>"Images", "width"=>90, "active"=>$last_active_tab == "idTabImages", "visible"=>true)
		));
?>
<?	if(isset($dw) && $mode=="update"){?>
<table width="100%" cellpadding="2" cellspacing="1" border="0" bgcolor="black">
	<tr>
		<td bgcolor="#ffffCC" style="color:red;" height="60" align="center">
			<b>
				Warning: Entered Product ID "<?=gs($product_id)?>" Already Exists in the Database.<br>
				Please Enter a Different Product ID.
			</b>
		</td>
	</tr>
</table>
&nbsp;
<?	}?>

<form name="frmProduct" action="admin.php?p=product_process" method="post" onsubmit="return CheckProductForm(this, '<?=$settings["WholesaleCasePack"]?>', '<?=$settings["WholesaleInterPack"]?>');" enctype="multipart/form-data" style="padding:0px;margin:0px;">
	<input type="hidden" name="pid" value="<?=$pid?>">
	<input type="hidden" name="mode" value="<?=$mode?>">
	<input type="hidden" name="last_active_tab" value="<?=$last_active_tab?>" id="idActiveTabHidden">

<?
	require_once("content/admin/admin_product_tab_info.php");
	require_once("content/admin/admin_product_tab_attributes.php");
	require_once("content/admin/admin_product_tab_inventory.php");
	require_once("content/admin/admin_product_tab_families.php");
	require_once("content/admin/admin_product_tab_images.php");
	require_once("content/admin/admin_product_tab_gifts.php");
	require_once("content/admin/admin_product_tab_discounts.php");
?>

<table width="100%" cellpadding="0" cellspacing="0" border="0">
	<tr>
		<td width="25%" align="left">
<?	if($prev_pid){?>
      		<img src="images/admin/arr_prev.gif"> <a href="admin.php?p=product&mode=update&pid=<?=$prev_pid?>">Edit previous product</a>
<?	}?>
			&nbsp;
    	</td>
		<td width="50%" class="formButtons">
			<input type="hidden" name="do_apply" value="no">
			<input type="image" src="images/admin/bt_save_changes.gif" default> &nbsp;
			<input type="image" onClick="frmProduct.reset();return false;" src="images/admin/bt_reset_form.gif">
		</td>
		<td width="25%" align="right">
			&nbsp;
<?	if($next_pid){?>
			<a href="admin.php?p=product&mode=update&pid=<?=$next_pid?>">Edit next product</a> <img src="images/admin/arr_next.gif">
<?	}?>
		</td>
	</tr>
</table>
</form>
<?	}
	else{
		pageHeader("Error Adding New Product", "", "ic_error.gif");
		if($products_count >= $iono->max_product_count && $mode == "insert"){
			pageNote(array(
				array("icon"=>"ic_error.gif", "text"=>"<b>Product cannot be added as you have reached the maximum number of products allowed.<br/>If you would like to upgrade your service, please contact customer support.</b>", "url"=>"",  "visible"=>true)
			));
		}
		else{
			pageNote(array(
				array("icon"=>"ic_error.gif", "text"=>"<b>Can't add a new product. Please add a new category first.</b>", "url"=>"",  "visible"=>true),
				array("icon"=>"ic_folder_new.gif", "text"=>"Click here to add a New Category", "url"=>"admin.php?p=category&mode=insert",  "visible"=>true)
			));
		}
	}
?>