<?php
	if (!defined("ENV")) exit();

	$group = isset($group)?intval($group):0;
	$settings_groups = array(
		"Company Information" => "",
		"Global Site Settings" => "",
		"Order/Cart Settings" => "",
		"Security Settings" => "",
		"Search Engines Settings" => "",
		"Bestsellers Settings" => "",
		"Wholesale Settings" => "This page is for businesses selling wholesale. Information here will be viewed on the \"Add a Product\" page as well as appearing to buyers on the front end of the website. ".$label_app_name." will calculate pricing using the following method. Case pack x(times) Unit Price",
		"Gift Message" => "",
		"Digital Products" => "",
		"Printable Invoice Settings" => "",
		"Proxy Settings" => "Proxy Settings",
		"PCI-DSS/PA-DSS compliance" => "PCI-DSS/PA-DSS compliance",
		//"buySAFE Settings" => "buySAFE Settings"
	);

	$settings_groups_short = array(
		"Company Information" => "Company contact information that appears<br> in customer communications on your website.",
		"Global Site Settings" => "Administration e-mails, support e-mails, path to SSL and other information about your cart.",
		"Order/Cart Settings" => "Website settings for how visitors interact with your cart.",
		"Security Settings" => "Cookie, timeout and gateway settings.",
		"Search Engines Settings" =>"Set your search engine Meta tags.",
		"Bestsellers Settings" => "Website settings for your most popular products.",
		"Wholesale Settings" => "Advance wholesale settings.",
		"Gift Message" => "Enable or disable gift messaging.",
		"Digital Products" => "Enable or disable digital produces and set download limits.",
		"Printable Invoice Settings" => "Edit company information from the printable invoice page.",
		"Proxy Settings" => "CURL Proxy Settings",
		"PCI-DSS/PA-DSS compliance" => "PCI-DSS/PA-DSS compliance",
		//"buySAFE Settings" => "Setup buySAFE features"
	);

	$settings_groups_icons = array(
		"Company Information" => "ic_admins.gif",
		"Global Site Settings" => "ic_settings.gif",
		"Order/Cart Settings" => "ic_orders.gif",
		"Security Settings" => "ic_locked.gif",
		"Bestsellers Settings" => "ic_bestsellers.gif",
		"Gift Message" => "ic_change_text.gif",
		"Digital Products" => "ic_digital.gif",
		"Printable Invoice Settings" => "ic_print.gif",
		"Proxy Settings" => "ic_settings.gif",
		"PCI-DSS/PA-DSS compliance" => "ic_settings.gif",
		//"buySAFE Settings" => "ic_settings.gif"
	);

if($group == 20 && !(_ACCESS_ALL || _ACCESS_DOWNLOADS)){
	pageHeader("Site Settings", "Digital Downloads", "ic_settings.gif");

	pageNote(array(
		array("icon"=>"ic_hint.gif", "text"=>"<b>This feature is not available under your license agreement. Please contact your provider to upgrade your application.</b>", "url"=>"", "visible"=>true)
	));
}
else{

	//check group
	$db->query("SELECT * FROM ".DB_PREFIX."settings WHERE visible='Yes' AND group_id='".$group."'");
	if($db->moveNext()){
		$group_name = $db->col["group_name"];
		//prepare page header / descriptions
		$a = array(
			0=>array("icon"=>"ic_hint.gif", "text"=>"Please note: required fields are in <b>bold</b>.", "url"=>"", "visible"=>true)
		);

		//add settings group description
		if(array_key_exists($group_name, $settings_groups)){
			if($settings_groups[$group_name] != ""){
				$a[2] = array("icon"=>"ic_hint.gif", "text"=>$settings_groups[$group_name], "url"=>"", "visible"=>true);
			}
		}

		if (isset($action))
		{
			//save settings
			if ($action == "update" && !DEMO_LOCK)
			{
				$form = isset($form)?$form:array();
				$check_weak_passwd = false;
				reset($form);

				foreach ($form as $key=>$value)
				{
					$db->query("UPDATE ".DB_PREFIX."settings SET value='".$db->escape($value)."' WHERE name LIKE '".$db->escape($key)."'");
					if($key == "SecurityForceCompliantAdminPasswords" && $value == "YES")
					{
						$check_weak_passwd = true;
					}

					if($key == "SecurityAdminActivyLogging")
					{
						if($settings["SecurityAdminActivyLogging"] != $value){
							adminLog("Logging is turned ".($value == "YES" ? "on" : "off"), false, true);
						}
					}

					$settings[$key] = $value;
				}
				$a[]= array("icon"=>"ic_hint.gif", "text"=>"<b><span style=\"color:#990000;\">Settings has been successfully saved</span></b>", "url"=>"", "visible"=>true);

				if($check_weak_passwd)
				{
					$weaks = "";
					$db->query("SELECT * FROM admins");
					while ($db->moveNext())
					{
						if($db->col["password_history"] != "")
						{
							$ph = unserialize(base64_decode($db->col["password_history"]));

							$ps = array_pop($ph);

							if($ps["s"] != 1){
								if ($admin_auth_id != $db->col["aid"])
								{
									$weaks .=
										($weaks == "" ? "" : ", ").
										'<a target="_blank" href="admin.php?p=admin&aid='.$db->col["aid"].'">'.htmlspecialchars($db->col["name"]).'</a>';
								}
								else
								{
									$weaks .=
										($weaks == "" ? "" : ", ").
										'<a target="_blank" href="admin.php?p=profile"><b>Your account</b></a>';
								}
							}
						}
					}


					if($weaks != "")
					{
						 $a[]= array("icon"=>"ic_warning.gif", "text"=>"<b><span style=\"color:#FF0000;\">PLEASE NOTE: One or more administrator(s) in the system have a weak password. Please make sure all passwords are updated to strong.</span></b><br/>".$weaks, "url"=>"", "visible"=>true);
					}
				}

			}
		}


		//display page header
		pageHeader("Site Settings", $group_name, "ic_settings.gif");

		//display page messages
		pageNote($a);

		pageTabs(array(
			array("title"=>$group_name, "id"=>"Main", "active"=>true, "width"=>140),
		));
		//generate script to check form values
?>
<script type="text/javascript" language="JavaScript" src="content/admin/javascript/jquery.ddm.core.js"></script>
<script type="text/javascript" language="JavaScript">
// checks IP address for Security Settings
function validateMultipleIps(ips)
{
	// flag used for return
	var found_error = false;

	// flag used to check if ip is valid
	var valid = true;

	// holds the ips to validate
	var ipArray = new Array();

	var sanitizedList = new Array();

	// used to determine if the user has entered their IP
	var found_user_ip = false;

	// trim whitespace
	ips = ips.replace(/ /, '');
	ipArray = ips.split(",");
	for (var i = 0; i < ipArray.length; i++)
	{
		var ip = $.trim(ipArray[i]);
		if (ip != '')
		{
			valid = $.ddm.validateIpFormat(
				{
					'ip': $.trim(ipArray[i]),
					'wildcard': true,
					'match_ip': true,
					'user_ip': '<?php echo $_SERVER["REMOTE_ADDR"];?>'
				});
			sanitizedList[sanitizedList.length] = ip;

			// if we receive -1, it means the admin IP matches the IP passed to validate
			if (valid === -1) {
				found_user_ip = true;
			}
			else if (!valid)
			{
				found_error = true;
			}
		}
	}

	if ((found_user_ip && $('select[name="form[SecurityAdminIpRestriction]"]').val() == 'Deny') || (!found_user_ip && $('select[name="form[SecurityAdminIpRestriction]"]').val() == 'Allow' && $.trim($('input[name="form[SecurityAdminIps]"]').val()) != ''))
	{
		alert('You cannot restrict access to yourself. Please check the Security Admin Ips setting.');
		return false;
	} else if (found_error) {
		alert('Please enter correct IP format for Security Admin Ips. if you are unsure, leave blank.');
	}

	$('input[name="form[SecurityAdminIps]"]').val(sanitizedList.join(','));
	return !found_error;
}

$(document).ready(function(){
	if ($('input[name="form[SecurityAdminIps]"]').get(0))
	{
		$('#btn_save_changes').click(function(){
			return validateMultipleIps($('input[name="form[SecurityAdminIps]"]').val());
		});
	}
});

function CheckSettingsForm(frm){
<?		$db->query("SELECT * FROM ".DB_PREFIX."settings WHERE visible='Yes' ".(trim($group)!=""?(" AND group_id='".$group."'"):"")." ORDER BY group_id, priority");
		while($db->moveNext()){
			//echo $db->col["validation"];
			if(trim($db->col["validation"]) != ""){
				switch($db->col["validation"]){
					case "url" : $func = "isText"; break;
					case "string" : $func = "isText"; break;
					case "phone" : $func = "isText"; break;
					case "int" : $func = "isInt"; break;
					case "email" : $func = "isEmail"; break;
					case "number" : $func = "checkNumber"; break;
					case "ip" : $func = 'checkIpAddress'; break;
				}
?>	if(!<?=$func?>(frm.elements["form[<?=trim($db->col["name"])?>]"].value)){
		alert("Please enter valid value for <?=trim($db->col["name"])?>");
		frm.elements["form[<?=trim($db->col["name"])?>]"].focus();
		return false;
	}
<?			}
		}
?>
	return true;
}
</script>
<form name="frmSettings" action="admin.php?p=settings&group=<?=urlencode($group)?>" method="post" onSubmit="return CheckSettingsForm(this)">
	<input type="hidden" name="action" value="update">

<div id="idTabSheetMain" class="sheetActive">
	<table width="100%" cellpadding="0" cellspacing="5" border="0">
<?php
		$db->query("SELECT * FROM ".DB_PREFIX."settings WHERE visible='Yes' ".(trim($group)!=""?(" AND group_id='".$group."'"):"")." ORDER BY group_id, priority");
		$group_name = "";
		$first = false;
		while ($db->moveNext())
		{
			if ($group_name != $db->col["group_name"])
			{
?>
		<tr>
			<td class="formHeader" colspan="2">
				<div class="formHeaderIcon"><img src="images/icons/ic_settings.gif"/></div>
				<div class="formHeaderText"><?=htmlspecialchars($db->col["group_name"])?></div>
			</td>
		</tr>
<?			$group_name = $db->col["group_name"];

			}
			$it = strtolower($db->col["input_type"]);
?>
		<tr valign="top">
			<td class="formItemCaption">
				<?=trim($db->col["validation"])!=""?"<b>":""?>
				<?=normalizeSettingsName($db->col["name"], $db->col["caption"])?>
				<?=trim($db->col["validation"])!=""?"</b>":""?>
			</td>
			<td class="formItemControl">
<?			switch($it){
				case "select" : {
					$v = explode(",", $db->col["options"]);
?>				<select name="form[<?=$db->col["name"]?>]" style="width:250px;">
<?					for($i=0; $i<count($v); $i++){
						$v[$i] = trim($v[$i]);
						if($v[$i] != ""){
							echo '<option value="'.$v[$i].'" '.($db->col["value"]==$v[$i]?"selected=\"selected\"":"").'>'.ucfirst(strtolower($v[$i])).'</option>';
						}
					}
?>
				</select>
<?
					break;
				}
				default :
				case "text" : {
?>
				<input type="text" name="form[<?=$db->col["name"]?>]" style="width:250px;" value="<?=gs($db->col["value"])?>">
<?					break;
				}
			}
?>
				<div class="formItemComment">
					<?=htmlspecialchars($db->col["description"])?>
				</div>
			</td>
		</tr>
<?			$first = false;
		}
?>
	</table>
</div>
<div class="formButtons">
	<input id="btn_save_changes" type="image" src="images/admin/bt_save_changes.gif"> &nbsp;
	<input type="image" src="images/admin/bt_reset_form.gif" onClick="frmSettings.reset();return false;">
</div>
</form>
<?
	}
	else
	{
		pageHeader("Global Cart Settings", "", "ic_settings.gif");
		pageNote(array(
			array("icon"=>"ic_hint.gif", "text"=>"<b>Please select the cart setting you would like to adjust:</b>", "url"=>"", "visible"=>true)
		));

		$db->query("SELECT * FROM ".DB_PREFIX."settings WHERE visible='Yes' GROUP BY group_name ORDER BY group_id");
		$a = array();
?>
<div class="settingsSpace">
	<ul>
<?php
		while ($db->moveNext())
		{
			if ($db->col["group_name"] == "buySAFE Settings") continue;
?>
		<li style="background-image:url('images/icons/<?=$settings_groups_icons[$db->col["group_name"]]?>')">
			<a href="admin.php?p=settings&group=<?=$db->col["group_id"]?>"><?=$db->col["group_name"]?></a>
			<div class="settingsItemComment">
				<?=$settings_groups_short[$db->col["group_name"]]?>
			</div>
		</li>
<?php
		}
?>
		<li style="background-image:url('images/icons/ic_search.gif')">
			<a href="admin.php?p=settings_search">Search Engine Settings</a>
			<div class="settingsItemComment">Search engine meta tags settings.</div>
		</li>

		<li style="background-image:url('images/icons/ic_globe.gif')">
			<a href="admin.php?p=products_locations">Products Locations Settings</a>
			<div class="settingsItemComment">Setup products shipment notifications for drop shippers, warehouses, stores, etc</div>
		</li>

		<li style="background-image:url('images/icons/ic_settings.gif')">
			<a href="admin.php?p=settings_wholesale">Wholesale Settings</a>
			<div class="settingsItemComment">Advanced Wholesale Support.</div>
		</li>

		<li style="background-image:url('images/icons/ic_email.gif')">
			<a href="admin.php?p=settings_email">POP3 and SMTP Email Settings</a>
			<div class="settingsItemComment">E-mail settings for SMTP server and for<br> deleting bounced e-mail messages.</div>
		</li>

		<li style="background-image:url('images/icons/ic_globe.gif')">
			<a href="admin.php?p=countries">Country List</a>
			<div class="settingsItemComment">Enable or disable countries you sell your products to. </div>
		</li>

		<li style="background-image:url('images/icons/ic_localization_settings.gif')">
			<a href="admin.php?p=localization">Languages &amp; Currencies</a>
			<div class="settingsItemComment">Set-up site currencies, change standard <br>messages and add different languages.</div>
		</li>
<?php
		if(IsPrivilege(array("ccs", "all"), $auth_rights))
		{
?>
		<li style="background-image:url('images/icons/ic_settings.gif')">
			<a href="admin.php?p=settings_ccs">CCS Settings</a>
			<div class="settingsItemComment">Setup payment storage, update password</div>
		</li>
<?php
		}
?>
   		<li style="background-image:url('images/icons/ic_settings.gif')">
			<a href="admin.php?p=compliance">PCI-DSS/PA-DSS compliance</a>
			<div class="settingsItemComment">PCI-DSS/PA-DSS compliance</div>
		</li>
	</ul>
</div>
<?php
	}
}
?>
