<?php
	if (!defined("ENV")) exit();

	require_once("content/classes/class.products.php");
	require_once("content/classes/class.taxes.php");
	require_once("content/classes/class.catalog.php");

	$class_id = isset($_REQUEST["class_id"])?intval($_REQUEST["class_id"]):0;
	$selected_cid = isset($_REQUEST["selected_cid"])?intval($_REQUEST["selected_cid"]):0;
	
	$taxes = new Taxes($db);
	$tax_class = $taxes->getTaxClassById($class_id);
	
	$mode = isset($_GET["mode"]) ? $_GET["mode"] : "";
	
	switch ($mode)
	{
		case "getProducts" :
		{
			$categories = isset($_GET["categories"]) ? $_GET["categories"] : "0";
			$categories = trim($categories) == "" ? "0" : $categories;
			$catagories = preg_match("/^([0-9\,])+$/", $categories) ? $categories : "0";
		
			if ($categories == "0")
			{
				$q = "SELECT pid, tax_class_id, title FROM ".DB_PREFIX."products ORDER BY title";
			}
			else
			{
				$q = "SELECT pid, tax_class_id, title FROM ".DB_PREFIX."products WHERE cid IN (".$categories.") ORDER BY title";
			}
			$db->query($q);
			echo json_encode(array("count"=>$db->numRows(), "products"=>$db->getRecords()));
			exit;
		}
		
		case "assignProducts" :
		{
			if ($tax_class)
			{
				$categories = isset($_GET["categories"]) ? $_GET["categories"] : "0";
				$categories = trim($categories) == "" ? "0" : $categories;
				$catagories = preg_match("/^([0-9\,])+$/", $categories) ? $categories : "0";

				$products = isset($_GET["products"]) ? $_GET["products"] : "0";
				$products = trim($products) == "" ? "0" : $products;
				$products = preg_match("/^([0-9\,])+$/", $products) ? $products : "0";
				
				/**
				 * Unassign old associations with current class
				 */
				if ($categories == "0")
				{
					$q = "UPDATE ".DB_PREFIX."products SET tax_class_id = 0 WHERE tax_class_id='".$class_id."'";
				}
				else
				{
					$q = "UPDATE ".DB_PREFIX."products SET tax_class_id = 0 WHERE tax_class_id='".$class_id."' AND cid IN (".$categories.")";
				}
				
				$db->query($q);
				
				/**
				 * Assign new products
				 */
				$db->query($q = "UPDATE ".DB_PREFIX."products SET tax_class_id = '".$class_id."', tax_rate='-1.00000' WHERE pid IN (".$products.")");
				echo json_encode(array("result"=>1));
				exit;
			}
		}
	}
	
	
	if ($tax_class)
	{
	
		/**
		 * Select categories
		 */
		$tree = array(0=>array("cid" => 0, "level" => 0, "is_visible" => "Yes", "key_name" => "", "name" => "All categories"));
		$db->query("SELECT * FROM ".DB_PREFIX."catalog ORDER BY level, priority, name");
		while($node = $db->moveNext())
		{
			$node["children"] = array();
			$tree[$node["cid"]] = $node;
			$tree[$node["parent"]]["children"][$node["cid"]] = &$tree[$node["cid"]];
		}
		
		/**
		 * Draw tree
		 */
		function drawTree(&$tree, $level)
		{
			foreach ($tree as $node)
			{
				if (!isset($node["level"]))
				{
					print_r($node);
				}
				if ($node["level"] == $level)
				{ 
					echo '<option value="'.$node["cid"].'">'.str_repeat("&nbsp;", $node["level"] * 4).htmlspecialchars($node["name"]).'</option>'."\n";
					if (count($node["children"]) > 0)
					{
						drawTree($node["children"], $level + 1);
					}
				}
			}
		}
		
		/**
		 * Show page
		 */
		pageHeader("Bulk Assign Tax Class - ".htmlspecialchars($tax_class["class_name"]));
		pageNote(array(
			array("icon"=>"ic_globe.gif", "text"=>"Back to Taxes Classes", "url"=>"admin.php?p=taxes&amp;last_active_tab=idTabClasses&amp;tax_mode=advanced", "visible"=>true)
		));
		pageTabs(array(
			array("title"=>"Tax Class Products", "id"=>"Main", "active"=>true, "width"=>140),
		));
?>
		<div id="idTabSheetMain" class="sheetActive" style="padding:0px;margin:0px;">
			<input type="hidden" id="tax_class_id" value="<?=$class_id?>"/>
			<form id="formTaxClassProducts" name="formTaxClassProducts">
				<table width="100%" cellpadding="0" cellspacing="5" border="0">
					<tr>
						<td class="formHeader" colspan="3">
							<div class="formHeaderIcon"><img src="images/icons/ic_globe.gif"/></div>
							<div class="formHeaderText">Tax Class - <?=htmlspecialchars($tax_class["class_name"])?></div>
						</td>
					</tr>
					<tr>
						<td align="center" height="360" width="49%" align="center" style="padding-left:25px;">
							<div align="left">Categories :</div>
							<select size="24" style="width:100%" id="selectCategories" name="categories" multiple="multiple">
								<option value="0" selected="selected">All Categories</option>
<?php							drawTree($tree, 1); ?>							
							</select>
						</td>
						<td align="center" width="2%">&nbsp;
						<!-- 
							<a href="javascript:moveFamily('families_a', 'families_p')"><img border="0" src="images/icons/ic_arrow_right2.gif" alt="Assign selected family with product"></a><br>&nbsp;<br>
							<a href="javascript:moveFamily('families_p', 'families_a')"><img border="0" src="images/icons/ic_arrow_left2.gif" alt="Unassign selected family with product"></a>
						 -->
						</td>
						<td align="center" height="360" width="49%" align="center" style="padding-right:25px;" >
							<div align="left" id="divProductsTitle">Products :</div>
							<select size="24" style="width:100%" id="selectProducts" name="products" multiple="multiple">
							</select>
						</td>
					</tr>
				</table>
				<div class="formButtons">
					<input type="button" value="Save Changes" id="buttonSaveChanges"/>
				</div>
			</form>
		</div>
	
		
		<script type="text/javascript" src="content/admin/javascript/taxes_class.js"></script>
<?php
	}
?>
