<?php
	if (!defined("ENV")) exit();

	$regions = new Regions($db);
	$countries_states = $regions->getCountriesStates(false);
	$taxes_classes = $taxes->getTaxClassesList();
	loadJS("regions.js");
	
	switch ($action)
	{
		case "deleteRate" :
		{
			$rate_id = isset($_REQUEST["rate_id"])?intval($_REQUEST["rate_id"]):0;
			$taxes->deleteRate($rate_id);
			break;
		}
		case "addRate" :
		{
			$country_data = $taxes->getCountryById($_REQUEST["coid"]);
			$state_data = $taxes->getStateById($_REQUEST["stid"]);
			$zone_name = ($country_data?$country_data["name"]:"All Countries")." - ".($state_data?$state_data["name"]:"All States");
			$zone_data = array(
				"zone_name" => $zone_name,
				"zone_description" => "Zone for ".$zone_name
			);
			
			$_REQUEST["zone_id"] = $added_zone_id = $taxes->addZone($zone_data);
			$taxes->addZoneRegion($added_zone_id, $_REQUEST["coid"], $_REQUEST["stid"]);
			
			$rate_id = $taxes->addRate($_REQUEST);
			
			$_REQUEST["rate_id"] = $rate_id;
			break;
		}
	}
	
	$taxes_rates = $taxes->getTaxRatesList();
	
	pageTabs(array(
		array("title"=>"Tax Rates", "id"=>"Main", "active"=>true, "width"=>140),
	));
?>
<script language="javascript" type="text/javascript"><!--
	function addSimpleTaxRate(){
		d = document.getElementById("divNewSimpleTaxRate");
		d.style.display = d.style.display == "none" ? "block" : "none";
	}
	
	function setSimpleTaxRateStates(){
		c = document.getElementById('selectSimpleTaxRateCountry');
		s = document.getElementById('selectSimpleTaxRateState');
		s.options.length = 1;
		s.options[0] = new Option('All States / Provinces', '0');
<?		foreach($countries_states as $coid=>$country){
			if(is_array($country["states"])){
?>		if(c.value == '<?=$coid?>'){<?
			$i = 1;
			foreach($country["states"] as $stid=>$state){?>
				s.options[<?=$i?>] = new Option('<?=addslashes($state)?>', '<?=$stid?>');		
<?				$i++;
			}
?>		}
<?			}
		}
?>
	}
--></script>
<script type="text/javascript" src="content/vendors/jquery/ddaccordion/ddaccordion.js"></script>
<script type="text/javascript">
ddaccordion.init({
	headerclass:"sliderButton", //Shared CSS class name of headers group
	contentclass:"sliderDiv", //Shared CSS class name of contents group
	collapseprev:false, //Collapse previous content (so only one open at any time)? true/false 
	defaultexpanded:[<?=!$taxes_rates?"0":""?>], //index of content(s) open by default [index1, index2, etc]. [] denotes no content.
	animatedefault:false, //Should contents open by default be animated into view?
	persiststate:false, //persist state of opened contents within browser session?
	toggleclass:["", ""], //Two CSS classes to be applied to the header when it's collapsed and expanded, respectively ["class1", "class2"]
	togglehtml:["src", "images/icons/ic_arrow_down.gif", "images/icons/ic_arrow_up.gif"], //Additional HTML added to the header when it's collapsed and expanded, respectively  ["position", "html1", "html2"] (see docs)
	animatespeed:"fast" //speed of animation: "fast", "normal", or "slow"
})
</script>
<div id="idTabSheetMain" class="sheetActive" style="padding:0px;margin:0px;">
	<form action="admin.php?p=taxes&tax_mode=simple" method="POST" style="margin:0px;padding:0px;" onsubmit="return checkAddTaxRate(this)">
		<input type="hidden" name="action" value="addRate"/>
		<table width="100%" cellpadding="0" cellspacing="5" border="0" style="clear:both;">
			<tr>
				<td class="formHeader" colspan="2">
					<div class="formHeaderIcon"><img src="images/icons/ic_insert_row.gif"/></div>
					<div class="formHeaderText">Add a New Tax Rate</div>
					<div class="formHeaderButtons"><img src="images/icons/ic_arrow_down.gif" class="sliderButton" style="cursor:pointer;"></div>
				</td>
			</tr>
		</table>
		<div class="sliderDiv" style="display:none">
			<table width="100%" cellpadding="0" cellspacing="5" border="0">
				<tr>
					<td class="formItemCaption"><b>Tax Rate Name</b></td>
					<td class="formItemControl">
						<input type="text" name="rate_description" style="width:250px" maxlength="255" value=""/>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Define a New Tax Zone</td>
					<td class="formItemControl">
						<select id="selectSimpleTaxRateCountry" name="coid" onchange="setSimpleTaxRateStates()" style="width:250px;">
							<option value="0">All Countries</option>
<?php							foreach($countries_states as $coid=>$country){
									echo '<option value="'.$coid.'">'.htmlspecialchars($country["country_name"]).'</option>';
								}
?>
						</select>
						<div style="padding-top:7px;">
							<select id="selectSimpleTaxRateState" name="stid" style="width:250px;">
								<option value="0">All States / Provinces</option>
							</select>
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Select a Tax Class</td>
					<td class="formItemControl">
						<select name="class_id" style="width:250px;">
<?php					for($i=0; $i<count($taxes_classes); $i++){?>
							<option value="<?=$taxes_classes[$i]["class_id"]?>"><?=htmlspecialchars($taxes_classes[$i]["class_name"])?></option>
<?php					}?>
						</select>
						<br/>
						<a href="admin.php?p=taxes&tax_mode=advanced&last_active_tab=idTabClasses">Click here to manage classes</a>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Rate Priority</td>
					<td class="formItemControl">
						<select name="rate_priority" style="width:123px;">
<?php					for($i=1; $i<=20; $i++){?>
							<option value="<?=$i?>"><?=$i?></option>
<?php						}?>
								
						</select>
						<div class="formItemComment">
							Rates at the same priority are added, others are compounded
						</div>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption"><b>Tax Rate, %</b></td>
					<td class="formItemControl">
						<input type="text" name="tax_rate" style="width:123px" value=""/>
					</td>
				</tr>
				<tr valign="top">
					<td class="formItemCaption">Apply To</td>
					<td class="formItemControl">
						<input type="checkbox" id="ul0" name="user_level[0]" value="0"/> <label for="ul0">Simple Users</label><br/>
						<input type="checkbox" id="ul1" name="user_level[1]" value="1"/> <label for="ul1">Wholesalers Level 1</label><br/>
						<input type="checkbox" id="ul2" name="user_level[2]" value="2"/> <label for="ul2">Wholesalers Level 2</label><br/>
						<input type="checkbox" id="ul3" name="user_level[3]" value="3"/> <label for="ul3">Wholesalers Level 3</label>
					</td>
				</tr>
			</table>
			<div class="formButtons">
				<input type="image" src="images/admin/bt_save_changes.gif"/>
				<input type="image" src="images/admin/bt_reset_form.gif" onclick="document.forms['frmCountries'].reset();return false;"/>
			</div>
		</div>
	</form>
	<div>
		<div class="listHeader">
			<div class="listHeaderIcon">&nbsp;</div>
			<div class="listHeaderCaption" style="width:150px;">Tax Rate Name</div>
			<div class="listHeaderCaption" style="width:100px;">Tax Rate</div>
			<div class="listHeaderCaption" style="width:90px;">Priority</div>
			<div class="listHeaderCaption" style="width:150px;">Class Name</div>
			<div class="listHeaderCaption" style="width:150px;">Zone Name</div>
		</div>
<?php
		if ($taxes_rates)
		{
			for ($i=0; $i<count($taxes_rates); $i++)
			{
				$tax_rate = $taxes_rates[$i];
?>
		<div class="listItem">
			<div class="listItemIcon">&nbsp;</div>
			<div class="listItemText" style="width:150px;"><?=htmlspecialchars($tax_rate["rate_description"])?></div>
			<div class="listItemText" style="width:100px;"><?=myNum($tax_rate["tax_rate"])?>%</div>
			<div class="listItemText" style="width:90px;"><?=htmlspecialchars($tax_rate["rate_priority"])?></div>
			<div class="listItemText" style="width:150px;"><?=htmlspecialchars($tax_rate["class_name"])?></div>
			<div class="listItemText" style="width:150px;"><?=htmlspecialchars($tax_rate["zone_name"])?></div>
			<div class="listItemButtons">
				<a href="admin.php?p=taxes_rate&mode=edit&rate_id=<?=$tax_rate["rate_id"]?>"><img border="0" src="images/icons/ic_change_text.gif" alt="Click to edit rate"/></a>
				<a href="javascript:confirmDeleteRateSimple('<?=$tax_rate["rate_id"]?>')"><img src="images/icons/ic_delete.gif" alt="Click to delete tax rate" border="0"/></a>
			</div>
		</div>
<?php
		}
	}
	else
	{
?>
		<div class="listEmpty">
			You do not have any tax rates setup . 
		</div>
<?	}?>
	</div>
</div>


