<?php
require_once("content/classes/class.gift_certificates.php");

//plugin class
class plugin_gift_cert extends cartPlugin
{
	//protected
	var $plugin_id = "gift_cert";
	var $plugin_group = "misc"; /* Group Name */
	var $plugin_caption = "Gift Certificates";
	var $plugin_description = "This plugin is used for gift certificates admin area.";

	//constructor
	function plugin_gift_cert()
	{
		$this->interface = array();
		$this->interface["title"] = $this->plugin_caption;
		$this->interface["url"] = 'admin.php?p=plugin&plugin_id='.$this->plugin_id;
		$this->interface["icon"] = "ic_cart";
		$this->interface["group"] = "products";

		return $this;
	}

	function runPlugin(&$db, &$settings, &$request)
	{
		parent::runPlugin($db, $settings, $request);
		extract($request);

		$gift_cert = new GiftCertificates($db);

		$action = isset($action)?trim($action):"";
		if (!DEMO_LOCK)
		{
			switch($action)
			{
				case "gift_cert_update" :
				{
					if ($gift_cert->UpdateGiftCertificate($_REQUEST))
					{
						$mode = '';
					}
					break;
				}
				case "gift_cert_delete" : 
				{
					if ($gift_cert->DeleteGiftCertificate($_REQUEST))
					{
						$mode = '';
					}
					break;
				}
				case "update_email" :
				{
					if (writeTemplateFile("templates/emails/gift_cert_html.html", stripslashes($_REQUEST['email_gift_cert'])))
					{
						$mode = '';
					}
					break;
				}
			}
		}

		pageHeader("Gift Certificates");
		pageNote(array(
			array("icon"=>"ic_hint.gif", "text"=>"Manage gift certificates.", "visible"=>true),
		));
		$last_active_tab = isset($last_active_tab)?trim($last_active_tab):"idTabGCSettings";
		pageTabs(array(
			array("title"=>"Gift Certificates Settings", "id"=>"GCSettings", "active"=>$last_active_tab == "idTabGCSettings", "width"=>150),
			array("title"=>"Gift Certificates Email", "id"=>"GCEmail", "active"=>$last_active_tab == "idTabGCEmail", "width"=>140),
		));
		$mode = isset($mode)?$mode:'';

		if ($gift_cert->is_error)
		{
			print "<font color=red><b>Errors:<br><br>";
			for ($i=0; $i < count($gift_cert->errors); $i++) 
			{
				print $gift_cert->errors[$i].'<br>';
			}
			print "</b></font>";
		}

		if (($mode == 'enable_module' || $mode == 'disable_module') && !DEMO_LOCK)
		{
			if ($mode == 'enable_module')
			{
				$set = 'Yes';
				$db->reset();
				$db->assign("parent", 0);
				$db->assign("level", 1);
				$db->assign("priority", 5);
				$db->assignStr("is_visible", 'No');
				$db->assignStr("key_name", 'gift_cert');
				$db->assignStr("name", 'gift_cert');
				$cid = $db->insert(DB_PREFIX."catalog");
				$db->reset();
				$db->assign("cid", $cid);
				$db->assign("added", 'now()');
				$db->assignStr("product_id", 'gift_certificate');
				$db->assignStr("title", 'Gift Certificate');
				$pid = $db->insert(DB_PREFIX."products");
			}
			else
			{
				$set = 'No';
				$db->query("DELETE FROM ".DB_PREFIX."catalog WHERE key_name='gift_cert' AND name='gift_cert'");
				$db->query("DELETE FROM ".DB_PREFIX."products WHERE product_id='gift_certificate' AND title='Gift Certificate'");
			}
			$settings['enable_gift_cert'] = $set;
			$db->reset();
			$db->assignStr('value', $set);
			$db->update(DB_PREFIX."settings", "WHERE name='enable_gift_cert'");
			$mode = '';
		}
?>
<div id="idTabSheetGCSettings" class="<?=$last_active_tab == "idTabGCSettings"?"sheetActive":"sheetUnactive"?>">


<?php
		if ($mode == 'update')
		{
			pageNote(array(
				array("icon"=>"ic_hint.gif", "text"=>"Modifying this information could cause a certificate to become invalid.", "visible"=>true),
			));
?>

		<form name="frmGiftCert" action="admin.php?p=plugin&plugin_id=<?=$this->plugin_id?>" method="post">
			<input type="hidden" name="ocid" value="<?=$ocid?>">
			<input type="hidden" name="mode" value="<?=$mode?>">
<?
			if (!$gift_cert->is_error)
			{
				$gift_data = $gift_cert->GetOrderedGiftCertById($ocid);
				$first_name = $gift_data['first_name'];
				$last_name = $gift_data['last_name'];
				$balance = $gift_data['balance'];
				$voucher = $gift_data['voucher'];
			}
?>
			<input type="hidden" name="action" value="gift_cert_update">
		<div style="clear:both;">
		<table width="100%" cellpadding="0" cellspacing="5" border="0">
			<tr>
				<td class="formHeader" colspan="2">
					<div class="formHeaderIcon"><img src="images/icons/ic_page.gif"/></div>
					<div class="formHeaderText">Gift Certificate Information</div>
				</td>
			</tr>
			<tr valign="top">
				<td class="formItemCaption"><b>First Name</b></td>
				<td class="formItemCaption">
					<input type="text" name="first_name" value="<?=htmlspecialchars($first_name)?>" style="width:250px;">
				</td>
			</tr>
			<tr valign="top">
				<td class="formItemCaption"><b>Last Name</b></td>
				<td class="formItemCaption">
					<input type="text" name="last_name" value="<?=htmlspecialchars($last_name)?>" style="width:250px;">
				</td>
			</tr>
			<tr valign="top">
				<td class="formItemCaption"><b>Balance</b></td>
				<td class="formItemCaption">
					<input type="text" name="balance" value="<?=myNum($balance)?>" style="width:123px;">
				</td>
			</tr>
			<tr valign="top">
				<td class="formItemCaption"><b>Voucher</b></td>
				<td class="formItemCaption">
					<input type="text" name="voucher" value="<?=htmlspecialchars($voucher)?>" style="width:250px;">
				</td>
			</tr>
			<tr>
				<td colspan="2" class="formButtons">
					<input type="image" src="images/admin/bt_save_changes.gif"> &nbsp;
					<input type="image" onClick="frmGiftCert.reset();return false;" src="images/admin/bt_reset_form.gif">
				</td>
			</tr>
		</table>
		</div>
		</form>
<?
		}
		else
		{
?>
<form name="frmGiftCertED" action="admin.php?p=plugin&plugin_id=<?=$this->plugin_id?>" method="post">
	<table width="100%" cellpadding="0" cellspacing="5" border="0">
		<tr>
			<td colspan="2" class="formHeader">
				<div class="formHeaderIcon"><img src="images/icons/ic_settings.gif"/></div>
				<div class="formHeaderText">Gift Certificate Module</div>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Current Status</td>
			<td class="formItemControl">
				<? if ($settings['enable_gift_cert'] == 'Yes') { ?>
				<input type="hidden" name="mode" value="disable_module" />
				<b>Enabled</b>
				<? } else { ?>
				<input type="hidden" name="mode" value="enable_module" />
				<b>Disabled</b><? } ?>
			</td>
		</tr>
		<tr valign="top">
			<td class="formItemCaption">Change Status</td>
			<td class="formItemControl">
				<? if ($settings['enable_gift_cert'] == 'Yes') { ?> <input type="submit" value="Disable Module" /> <? } else { ?><input type="submit" value="Enable Module" /><? } ?>
			</td>
		</tr>
	</table>
	</form>
<?
		}
?>
	</div>
<?php
$email_gift_cert = readTemplateFile("templates/emails/gift_cert_html.html");

?>
	<div id="idTabSheetGCEmail" class="<?=$last_active_tab == "idTabGCEmail"?"sheetActive":"sheetUnactive"?>">
		<form name="frmGiftCert" action="admin.php?p=plugin&plugin_id=<?=$this->plugin_id?>" method="post">
		<input type="hidden" name="action" value="update_email" />
		<table width="100%" cellpadding="0" cellspacing="5"" border="0">
		<tr>
			<td class="formHeader">
				<div class="formHeaderIcon"><img src="images/icons/ic_change_text.gif"/></div>
				<div class="formHeaderText">Gift Certificate HTML Emai [<a href="javascript:toggleEditorMode('email_gift_cert',this)">Edit HTML Online</a> ]</div>
			</td>
		</tr>
		<tr>
			<td class="formItemBig">
				<textarea wrap="off" cols="50" rows="8" style="width:100%;height:350px;" class="no-mce" id="email_gift_cert" name="email_gift_cert"><?=htmlentities(stripslashes($email_gift_cert))?></textarea>
			</td>
		</tr>
		<tr>
			<td class="formButtons">
				<input type="image" src="images/admin/bt_save_changes.gif"> &nbsp;
				<input type="image" src="images/admin/bt_reset_form.gif" onClick="frmTaxes.reset();return false;">
			</td>
		</tr>
		</table>
		</form>
	</div>
<?
	$this->printGiftCertificates($gift_cert);
	}


	function printGiftCertificates($gift_cert) {
		if(!isset($_REQUEST['show_balance'])){
			$_REQUEST['show_balance'] = '0';
		}
		global $settings;

		?>
		<script>
			function ConfirmDeleteGiftCert(ocid) {
				if (!confirm('Are you sure you want to delete this gift certificate?'))
					return false;
				document.location.href='admin.php?p=plugin&plugin_id=<?=$this->plugin_id?>&action=gift_cert_delete&ocid='+ocid;
			}
		</script>
		<br/><br/>
		<form name="frmGCSetting" action="admin.php?p=plugin&plugin_id=<?=$this->plugin_id?>" method="post" id="frmGCSetting">
		<div class="listHeader">
			<div class="listHeaderIcon">&nbsp;</div>
			<div class="listHeaderCaption" style="width:130px;">Client's Name</div>
			<div class="listHeaderCaption" style="width:130px;">Voucher Number</div>
			<div class="listHeaderCaption" style="width:80px;">Balance</div>
			<div class="listHeaderCaption" style="width:180px;">Gift Message</div>
			<div class="listHeaderCaption" style="width:130px;">Recipient Email</div>
			<div class="listHeaderCaption" style="width:130px;">Date Ordered</div>
			<div class="listHeaderCaption" style="text-location:right">
				<select name="show_balance" onchange="document.getElementById('frmGCSetting').submit();">
					<option value="0" <?=($_REQUEST['show_balance']=='0'?'selected':'')?>>Show All Gift Certificates</option>
					<option value="1" <?=($_REQUEST['show_balance']=='1'?'selected':'')?>>Show Balance Zero</option>
					<option value="2" <?=($_REQUEST['show_balance']=='2'?'selected':'')?>>Show Valid Gift Certificates</option>
				</select>
			</div>
		</div>
		<?
			if ($_REQUEST['show_balance'] == '1') {
				$where = 'WHERE balance = 0';
			} else if ($_REQUEST['show_balance'] == '2') {
				$where = 'WHERE balance > 0';
			} else {
				$where = '';
			}

			$gift_cert_list = $gift_cert->GetGiftCertificates($where);

			if(is_array($gift_cert_list) && count($gift_cert_list) > 0){
				for($i=0; $i<count($gift_cert_list); $i++) {
		?>
			<div class="listItem">
				<div class="listHeaderIcon">&nbsp;</div>
				<div class="listItemText" style="width:130px;"><?=$gift_cert_list[$i]['first_name']." ".$gift_cert_list[$i]['last_name']?></div>
				<div class="listItemText" style="width:130px;"><?=$gift_cert_list[$i]['voucher']?></div>
				<div class="listItemText" style="width:80px;"><?='$ '.number_format($gift_cert_list[$i]['balance'], 2, '.', '')?></div>
                <div class="listItemText" style="width:180px;"><?=$gift_cert_list[$i]['message']?></div>
				<div class="listItemText" style="width:130px;"><?=$gift_cert_list[$i]['email']?></div>
				<div class="listItemText" style="width:130px;"><?=$gift_cert_list[$i]['date_ordered']?></div>
				<div class="listItemButtons">
					<a href="admin.php?p=plugin&plugin_id=<?=$this->plugin_id?>&mode=update&ocid=<?=$gift_cert_list[$i]['ocid']?>"><img src="images/icons/ic_change_text.gif" border="0" title="Edit Gift Certificate"></a>
					<a href="javascript:ConfirmDeleteGiftCert(<?=$gift_cert_list[$i]['ocid']?>); void(0);"><img src="images/icons/ic_delete.gif" border="0" title="Delete Gift Certificate"></a>
				</div>
			</div>
		<?		}
			}
			else{
		?>
			<div class="listEmpty" ><b>No gift certificates found</b></div>

		<?
			}
		?>

		</form>

		<?
	}
}
