<?php

	function om_normalize($s){
		return htmlspecialchars(utf8_encode(($s)));
	}

	//plugin web interface
	if(!class_exists("cartPlugin")){
		$include_path = "../../../";
		require($include_path."engine/engine_config.php");
		require($include_path."engine/engine_mysql.php");
		require($include_path."classes/class.openssl.php");
		
		require($include_path."engine/engine_localization.php");
		require($include_path."engine/engine_order.php");
		require($include_path."classes/class.plugins.php");
		$db = new DB;
		$db->init(DB_HOST, DB_USER, DB_PASSWORD, DB_NAME);
		
		require($include_path."engine/engine_settings.php");
		
		$setifunction = isset($_REQUEST["setifunction"])?trim($_REQUEST["setifunction"]):"";
		$setiuser = isset($_REQUEST["setiuser"])?trim($_REQUEST["setiuser"]):"";
		$password = isset($_REQUEST["password"])?trim($_REQUEST["password"]):"";
		
		// check auth
		$plugin_auth = true;
		
		$setitypes = array(
			"downloadorders"=>"SETIOrders",
			"downloadcustomers"=>"SETICustomers",
			"downloadprods"=>"SETIProducts",
			"downloadqoh"=>"SETIProducts"
		);
		
		if($setifunction != "sendversion"){
			$plugin_active = $settings["plugin_stone_edge_order_manager_active"];
			$plugin_username = $settings["plugin_stone_edge_order_manager_username"];
			$plugin_password =$settings["plugin_stone_edge_order_manager_password"];
			$global_http_url = $settings["GlobalHttpUrl"];
			
			if($plugin_active == "NO" || $plugin_username != $setiuser || $plugin_password != $password){
				$plugin_auth = false;
			}
		}
		
		if($plugin_auth){
			if($_SERVER["SERVER_PORT"] != 443 && !defined("DEVMODE")){
				$plugin_auth = false;
			}
		}
		
		if($plugin_auth){
			switch($setifunction){

				//Requesting Script Version Data
				case "sendversion" : {
					echo "SetiResponse: version=1.000";
					break;
				}

				//Determining the number of orders to download
				case "ordercount" : {
					$lastorder = isset($_REQUEST["lastorder"])?trim($_REQUEST["lastorder"]):"";
					$lastdate = isset($_REQUEST["lastdate"])?trim($_REQUEST["lastdate"]):"";
					$sql = "SELECT COUNT(*) AS ordercount FROM ".DB_PREFIX."orders WHERE status <> 'Abandon' AND status <>  'New'";
					if(is_numeric($lastorder)){
						$sql.=" AND order_num >= ".$lastorder;
					}
					if($lastdate != "all"){
						//transorm from mm/dd/yyyy to yyyy-mm-dd
						$_date = explode("/", $lastdate);
						if(count($_date) == 3 && is_numeric($_date[0]) && is_numeric($_date[1])&& is_numeric($_date[2])){
							$sql.=" AND create_date>='".$_date[2]."-".$_date[0]."-".$_date[1]." 00:00:01'";
						}
					}
					$db->query($sql);
					$result = $db->moveNext();
					$ordercount = $result["ordercount"];
					echo "SetiResponse: ordercount=".$ordercount;
					break;
				}
				
				//Downloading Orders
				case "downloadorders" : {
					$lastorder = isset($_REQUEST["lastorder"])?trim($_REQUEST["lastorder"]):"";
					$lastdate = isset($_REQUEST["lastdate"])?trim($_REQUEST["lastdate"]):"all";
					$startnum = isset($_REQUEST["startnum"])?trim($_REQUEST["startnum"]):"";
					$batchsize = isset($_REQUEST["batchsize"])?trim($_REQUEST["batchsize"]):"";
					$dkey = isset($_REQUEST["dkey"])?trim($_REQUEST["dkey"]):"";
					$sql = 
						"SELECT ".DB_PREFIX."orders.*, ".DB_PREFIX."users.*, ".
						"IF(".DB_PREFIX."users.country=1 OR ".DB_PREFIX."users.country=2, bstate.short_name, ".DB_PREFIX."users.province) AS billing_state_name, bcountry.iso_a2 AS billing_country_name, ".
						"IF(".DB_PREFIX."orders.shipping_country=1 OR ".DB_PREFIX."orders.shipping_country=2, sstate.short_name, ".DB_PREFIX."orders.shipping_province) AS shipping_state_name, scountry.iso_a2 AS shipping_country_name ".
						"FROM ".DB_PREFIX."orders ".
						"INNER JOIN ".DB_PREFIX."users ON ".DB_PREFIX."orders.uid=".DB_PREFIX."users.uid ".
						"LEFT JOIN ".DB_PREFIX."states AS bstate ON bstate.stid=".DB_PREFIX."users.state ".
						"INNER JOIN ".DB_PREFIX."countries AS bcountry ON bcountry.coid=".DB_PREFIX."users.country ".
						"LEFT JOIN ".DB_PREFIX."states AS sstate ON sstate.stid=".DB_PREFIX."orders.shipping_state ".
						"INNER JOIN ".DB_PREFIX."countries AS scountry ON scountry.coid=".DB_PREFIX."orders.shipping_country ".
						"WHERE status <> 'Abandon'";
					if(is_numeric($lastorder)){
						$sql.=" AND order_num > ".$lastorder;
					}
					if($lastdate != "all"){
						$_date = explode("/", $lastdate);
						if(count($_date) == 3 && is_numeric($_date[0]) && is_numeric($_date[1])&& is_numeric($_date[2])){
							$sql.=" AND create_date >='".$_date[2]."-".$_date[0]."-".$_date[1]." 00:00:01'";
						}
					}
					if(is_numeric($startnum)){
						$sql.=" AND order_num > ".$startnum;
					}
					if(is_numeric($batchsize)){
						$sql.=" LIMIT ".$batchsize;
					}
					//select order from db
					//echo $sql;
					$db->query($sql);
					if($db->numRows() > 0){
						$orders = $db->getRecords();
											
						echo '<?xml version="1.0"?>'."\n";
						echo '<SETIOrders>'."\n";
						echo '<Response>'."\n";
						echo '<ResponseCode>1</ResponseCode>'."\n";
						echo '<ResponseDescription>success</ResponseDescription>'."\n";
						echo '</Response>'."\n";
						foreach($orders as $order){
							echo '<Order>';
							echo '<OrderNumber>'.$order["order_num"].'</OrderNumber>'."\n";
							echo '<OrderDate>'.$order["create_date"].'</OrderDate>'."\n";
							echo '<Billing>'."\n";
							echo '<FullName>'.om_normalize($order["fname"].' '.$order["lname"]).'</FullName>'."\n";
							echo '<Email>'.om_normalize($order["email"]).'</Email>'."\n";
							echo '<Company>'.om_normalize($order["company"]).'</Company>'."\n";
							echo '<Phone>'.om_normalize($order["phone"]).'</Phone>'."\n";
							echo '<Address>'."\n";
							echo '<Street1>'.om_normalize($order["address1"]).'</Street1>'."\n";
							echo '<Street2>'.om_normalize($order["address2"]).'</Street2>'."\n";
							echo '<City>'.om_normalize($order["city"]).'</City>'."\n";
							echo '<State>'.om_normalize($order["billing_state_name"]).'</State>'."\n";
							echo '<Code>'.om_normalize($order["zip"]).'</Code>'."\n";
							echo '<Country>'.om_normalize($order["billing_country_name"]).'</Country>'."\n";
							echo '</Address>'."\n";
							echo '</Billing>'."\n";
							echo '<Shipping>'."\n";
							echo '<FullName>'.om_normalize($order["shipping_name"]).'</FullName>'."\n";
							echo '<Company>'.om_normalize($order["shipping_company"]).'</Company>'."\n";
							echo '<Phone></Phone>'."\n";
							echo '<Address>'."\n";
							echo '<Street1>'.om_normalize($order["shipping_address1"]).'</Street1>'."\n";
							echo '<Street2>'.om_normalize($order["shipping_address2"]).'</Street2>'."\n";
							echo '<City>'.om_normalize($order["shipping_city"]).'</City>'."\n";
							echo '<State>'.om_normalize($order["shipping_state_name"]).'</State>'."\n";
							echo '<Code>'.om_normalize($order["shipping_zip"]).'</Code>'."\n";
							echo '<Country>'.om_normalize($order["shipping_country_name"]).'</Country>'."\n";
							echo '</Address>'."\n";
							
							$order_weight = 0;
							$db->query("SELECT * FROM ".DB_PREFIX."orders_content WHERE oid='".$order["oid"]."'");
							while (($product = $db->moveNext()) != 0)
							{
								$sku = $product["product_sub_id"]!=""?$product["product_sub_id"]:$product["product_id"];
								echo '<Product>'."\n";
								echo '<ProdType>'.($product["digital_product"]=="Yes"?"Download":"Tangible").'</ProdType>'."\n";
								echo '<SKU>'.om_normalize($sku).'</SKU>'."\n";
								echo '<Taxable>'.$product["is_taxable"].'</Taxable>'."\n";
								echo '<Quantity>'.$product["admin_quantity"].'</Quantity>'."\n";
								echo '<Name>'.om_normalize($product["title"]).'</Name>'."\n";
								echo '<ItemPrice>'.number_format($product["admin_price"], 2, ".", "").'</ItemPrice>'."\n";
								echo '<Total>'.number_format($product["admin_price"]*$product["admin_quantity"], 2, ".", "").'</Total>'."\n";
								echo '<Weight>'.$product["weight"].'</Weight>'."\n";
								echo '<Dimension>'."\n";
								echo '<Length>0</Length>'."\n";

								echo '<Width>0</Width>'."\n";
								echo '<Height>0</Height>'."\n";
								echo '</Dimension>'."\n";
								$order_weight = $order_weight + $product["weight"] * $product["admin_quantity"];
								if(trim($product["options_clean"]) != ""){
									$options = explode("\n", $product["options_clean"]);
									for($j=0; $j<count($options); $j++){
										$option = explode(":", $options[$j]);
										$option_name = trim($option[0]);
										//check for modifiers
										$option_part2 = $option[1];
										if(strstr($option_part2, "(") && strstr($option_part2, ")")){
											$option_part3 = explode("(", $option_part2);
											$option_value = trim($option_part3[0]);
											$option_modifier = str_replace(")", " ", $option_part3[1]);
											if(strstr($option_modifier, ",")){
												$option_modifier_parts = explode(",", $option_modifier);
												$option_modifier_price = $option_modifier_parts[0];
												$option_modifier_weight = $option_modifier_parts[1];
											}
											else{
												$option_modifier_price = $option_modifier;
												$option_modifier_weight = 0;
											}
										}
										else{
											$option_value = trim($option_part2);
											$option_modifier_price = 0;
											$option_modifier_weight = 0;
										}
										
										
										
										echo '<OrderOption>'."\n";
										echo '<OptionName>'.om_normalize($option_name).'</OptionName>'."\n";
										echo '<SelectedOption>'.om_normalize($option_value).'</SelectedOption>'."\n";
										echo '<OptionPrice>'.om_normalize($option_modifier_price).'</OptionPrice>'."\n";
										//echo '<OptionCode>'.om_normalize($options[$j]).'</OptionCode>'."\n";
										echo '<OptionType>select</OptionType>'."\n";
										echo '<OptionWeight>'.om_normalize($option_modifier_weight).'</OptionWeight>'."\n";
										echo '<OptionCost>+0.00</OptionCost>'."\n";
										echo '</OrderOption>'."\n";
									}
								}
								echo '</Product>'."\n";
							}
							echo '</Shipping>'."\n";
							
							$db->query("SELECT * FROM ".DB_PREFIX."payment_transactions WHERE oid='".$order["oid"]."'");
							if (!($transaction = $db->moveNext()))
							{
								$transaction["extra"] = "";
								$transaction["payment_gateway"] = "";
							}
							if($dkey != ""){
								$card_data = unserialize(urldecode($order["card_data"]));								
								$ds = DIRECTORY_SEPARATOR;
								$openSSL = new openSSL(4096, OPENSSL_KEYTYPE_RSA, 3650, $settings["GlobalServerPath"].$ds."content".$ds."ssl".$ds."openssl.cnf");
								$decrypted = $openSSL->decrypt($card_data["cr"], $dkey, base64_decode($settings["SecurityCCSPrivateKey"]));
								if($decrypted){
									$cc_data = unserialize($decrypted);									
									$show_cc_data = true;
								}
								else{
									echo "Can't get CC data. Please try different password";
									$show_cc_data = false;
								}
							}
							echo '<Payment>'."\n";
							echo '<CreditCard>'."\n";
							if($show_cc_data){							
								echo '<Issuer>'.om_normalize($cc_data["ct"]).'</Issuer>'."\n";
								echo '<Number>'.om_normalize($cc_data["cc"]).'</Number>'."\n";
								echo '<VerificationValue>Y</VerificationValue>'."\n";
								echo '<ExpirationDate>'.om_normalize($cc_data["em"].'/'.$cc_data["ey"]).'</ExpirationDate>'."\n";
								echo '<FullName>'.om_normalize($cc_data["fn"].' '.$cc_data["ln"]).'</FullName>'."\n";								
							}else{
								echo '<Issuer>** SECURED **</Issuer>'."\n";
								echo '<Number>** SECURED **</Number>'."\n";
								echo '<VerificationValue>Y</VerificationValue>'."\n";
								echo '<ExpirationDate>00/0000</ExpirationDate>'."\n";
								echo '<FullName>'.om_normalize($order["fname"].' '.$order["lname"]).'</FullName>'."\n";								
							}
							
							echo '<Company>'.om_normalize($transaction["payment_gateway"]).'</Company>'."\n"; 
							echo '<OrderProcessingInfo>'.om_normalize($transaction["payment_gateway"].":  ".$transaction["extra"]).'</OrderProcessingInfo>'."\n";
							echo '<AVS>YYY</AVS>'."\n";
							echo '<TransID>'.$order["oid"].'</TransID>'."\n";
							echo '<AuthCode>'.$order["security_id"].'</AuthCode>'."\n";
							echo '<ProcessLevel>Capture</ProcessLevel>'."\n";
							echo '</CreditCard>'."\n";
							echo '</Payment>'."\n";
							
							
							echo '<Totals>'."\n";
							echo '<ProductTotal>'.number_format($order["subtotal_amount"], 2, ".", "").'</ProductTotal>'."\n";
							if($order["discount_type"] != "none"){
								echo '<Discount>'."\n";
								echo '<Type>'.($order["discount_type"]=="amount"?"Flat":"Percent").'</Type>'."\n";
								if($order["discount_type"] == "percent"){
									echo '<Percent>'.number_format($order["discount_value"], 2, ".", "").'</Percent>'."\n";
								}
								echo '<Amount>'.number_format($order["discount_amount"], 2, ".", "").'</Amount>'."\n";
								echo '<ApplyDiscount>Pre</ApplyDiscount>'."\n";
								echo '</Discount>'."\n";
							}
							echo '<Subtotal>'.number_format($order["subtotal_amount"] - $order["discount_amount"], 2, ".", "").'</Subtotal>'."\n";
							echo '<Tax>'."\n";
							echo '<TaxShipping>'.($order["shipping_taxable"]?"Yes":"No").'</TaxShipping>'."\n";
							echo '<TaxAmount>'.number_format($order["tax_amount"], 5, ".", "").'</TaxAmount>'."\n";
							echo '<TaxRate>0.00</TaxRate>'."\n";
							echo '</Tax>'."\n";
							echo '<GrandTotal>'.number_format($order["total_amount"], 2, ".", "").'</GrandTotal>'."\n";
							echo '<ShippingTotal>'."\n";
							echo '<Total>'.number_format($order["shipping_amount"], 2, ".", "").'</Total>'."\n";
							echo '<Description>'.om_normalize($order["shipping_carrier_id"]." ".$order["shipping_cm_name"]).'</Description>'."\n";
							echo '</ShippingTotal>'."\n";
							if($order["handling_separated"] && $order["handling_amount"] > 0){
								echo '<Surcharge>'."\n";
								echo '<Total>'.number_format($order["handling_amount"], 2, ".", "").'</Total>'."\n";
								echo '<Description>Handling Fee</Description>'."\n";
								echo '</Surcharge>'."\n";
							}
							echo '</Totals>'."\n";
							echo '<Other>'."\n";
							echo '<Associate/>'."\n";
							echo '<OrderInstructions></OrderInstructions>'."\n";
							echo '<Comments></Comments>'."\n";
							echo '<IpHostname></IpHostname>'."\n";
							echo '<TotalOrderWeight>'.$order_weight.'</TotalOrderWeight>'."\n";
							echo '<EmailList>'.(($order["newsletters"] == "Yes" || $order["updates"] == "Yes")?om_normalize($order["email"]):"").'</EmailList>'."\n";
							
							$db->query(
								"SELECT ".DB_PREFIX."custom_fields_values.field_value, ".DB_PREFIX."custom_fields.field_name ".
								"FROM ".DB_PREFIX."custom_fields_values ".
								"INNER JOIN ".DB_PREFIX."custom_fields ON ".DB_PREFIX."custom_fields_values.field_id=".DB_PREFIX."custom_fields.field_id ".
								"WHERE order_id='".$order["oid"]."'"
							);
							if($db->numRows() > 0){
								while(($cf = $db->moveNext()) != false){
									echo '<CustomCheckoutField>'."\n";
									echo '<FieldName>'.$cf["field_name"].'</FieldName>'."\n";
									echo '<FieldValue>'.$cf["field_value"].'</FieldValue>'."\n";
									echo '</CustomCheckoutField>'."\n";
								}
							}
							echo '</Other>'."\n";
							echo '</Order>';
						}
						echo '</SETIOrders>'."\n";
					}
					else{
						echo '<?xml version="1.0"?>'."\n";
						echo '<SETIOrders>'."\n";
						echo '<Response>'."\n";
						echo '<ResponseCode>2</ResponseCode>'."\n";
						echo '<ResponseDescription>success</ResponseDescription>'."\n";
						echo '</Response>'."\n";
						echo '</SETIOrders>'."\n";
					}
					break;
				}
				//Determining the number of customers to download
				case "getcustomerscount" : {
					$sql = "SELECT COUNT(*) AS usercount FROM ".DB_PREFIX."users";
					$db->query($sql);
					$result = $db->moveNext();
					$usercount = $result["usercount"];
					echo "SetiResponse: itemcount=".$usercount;
					break;
				}
				
				//Downloading Customer Data
				case "downloadcustomers" : {
					$startnum = isset($_REQUEST["startnum"])?trim($_REQUEST["startnum"]):"";
					$batchsize = isset($_REQUEST["batchsize"])?trim($_REQUEST["batchsize"]):"";
					$sql = 
						"SELECT ".DB_PREFIX."users.*, ".
							DB_PREFIX."users_shipping.name AS shipping_name, ".
							DB_PREFIX."users_shipping.company AS shipping_company, ".
							DB_PREFIX."users_shipping.address1 AS shipping_address1, ".
							DB_PREFIX."users_shipping.address2 AS shipping_address2, ".
							DB_PREFIX."users_shipping.city AS shipping_city, ".
							DB_PREFIX."users_shipping.zip AS shipping_zip, ".
						"IF(".DB_PREFIX."users.country=1 OR ".DB_PREFIX."users.country=2, bstate.short_name, ".DB_PREFIX."users.province) AS billing_state_name, bcountry.iso_a2 AS billing_country_name, ".
						"IF(".DB_PREFIX."users_shipping.country=1 OR ".DB_PREFIX."users_shipping.country=2, sstate.short_name, ".DB_PREFIX."users_shipping.province) AS shipping_state_name, scountry.iso_a2 AS shipping_country_name ".
						"FROM users ".
						"LEFT JOIN ".DB_PREFIX."states AS bstate ON bstate.stid=".DB_PREFIX."users.state ".
						"LEFT JOIN ".DB_PREFIX."countries AS bcountry ON bcountry.coid=".DB_PREFIX."users.country ".
						
						"LEFT JOIN ".DB_PREFIX."users_shipping ON ".DB_PREFIX."users_shipping.uid=".DB_PREFIX."users.uid AND ".DB_PREFIX."users_shipping.is_primary='Yes' ".
						"LEFT JOIN ".DB_PREFIX."states AS sstate ON sstate.stid=".DB_PREFIX."users_shipping.state ".
						"LEFT JOIN ".DB_PREFIX."countries AS scountry ON scountry.coid=".DB_PREFIX."users_shipping.country ".
						"WHERE ".DB_PREFIX."users.uid>0 ";
						
						
					if(is_numeric($startnum)){
						$sql.=" AND ".DB_PREFIX."users.uid >= ".$startnum;
					}
					
					$sql.=" GROUP BY ".DB_PREFIX."users.uid ORDER BY uid ";
					
					if(is_numeric($batchsize)){
						$sql.=" LIMIT ".$batchsize;
					}
					
					$db->query($sql);
					if($db->numRows()>0){
						echo '<?xml version="1.0"?>'."\n";
						echo '<SETICustomers>'."\n";
						echo '<Response>'."\n";
						echo '<ResponseCode>1</ResponseCode>'."\n";
						echo '<ResponseDescription>success</ResponseDescription>'."\n";
						echo '</Response>'."\n";
						while (($customer = $db->moveNext()) != false)
						{
							echo '<Customer>'."\n";
							echo '<WebID>'.$customer["uid"].'</WebID>'."\n";
							echo '<UserName>'.om_normalize($customer["login"]).'</UserName>'."\n";
							echo '<Password>'.om_normalize($customer["password"]).'</Password>'."\n";
							echo '<AffiliateID></AffiliateID>'."\n";
							echo '<BillAddr>'."\n";
							echo '<FirstName>'.om_normalize($customer["fname"]).'</FirstName>'."\n";
							echo '<LastName>'.om_normalize($customer["lname"]).'</LastName>'."\n";
							echo '<Email>'.om_normalize($customer["email"]).'</Email>'."\n";
							echo '<Company>'.om_normalize($customer["company"]).'</Company>'."\n";
							echo '<Phone>'.om_normalize($customer["phone"]).'</Phone>'."\n";
							echo '<Fax>'.om_normalize($customer["phone"]).'</Fax>'."\n";
							echo '<Addr1>'.om_normalize($customer["address1"]).'</Addr1>'."\n";
							echo '<Addr2>'.om_normalize($customer["address2"]).'</Addr2>'."\n";
							echo '<City>'.om_normalize($customer["city"]).'</City>'."\n";
							echo '<State>'.om_normalize($customer["billing_state_name"]).'</State>'."\n";
							echo '<Zip>'.om_normalize($customer["zip"]).'</Zip>'."\n";
							echo '<Country>'.om_normalize($customer["billing_country_name"]).'</Country>'."\n";
							echo '<TaxIDNumber></TaxIDNumber>'."\n";
							echo '</BillAddr>'."\n";
							
							echo '<ShipAddr>'."\n";
							echo '<FirstName>'.om_normalize($customer["shipping_name"]).'</FirstName>'."\n";
							echo '<LastName>'.om_normalize($customer["shipping_name"]).'</LastName>'."\n";
							echo '<Email>'.om_normalize($customer["email"]).'</Email>'."\n";
							echo '<Company>'.om_normalize($customer["shipping_company"]).'</Company>'."\n";
							echo '<Phone>'.om_normalize($customer["shipping_name"]).'</Phone>'."\n";
							echo '<Fax>'.om_normalize($customer["phone"]).'</Fax>'."\n";
							echo '<Addr1>'.om_normalize($customer["shipping_address1"]).'</Addr1>'."\n";
							echo '<Addr2>'.om_normalize($customer["shipping_address2"]).'</Addr2>'."\n";
							echo '<City>'.om_normalize($customer["shipping_city"]).'</City>'."\n";
							echo '<State>'.om_normalize($customer["shipping_state_name"]).'</State>'."\n";
							echo '<Zip>'.om_normalize($customer["shipping_zip"]).'</Zip>'."\n";
							echo '<Country>'.om_normalize($customer["shipping_country_name"]).'</Country>'."\n";
							echo '</ShipAddr>'."\n";

							
							echo '</Customer>'."\n";
						}

						echo '</SETICustomers>'."\n";
					}
					else{
						echo '<?xml version="1.0"?>'."\n";
						echo '<SETICustomers>'."\n";
						echo '<Response>'."\n";
						echo '<ResponseCode>2</ResponseCode>'."\n";
						echo '<ResponseDescription>success</ResponseDescription>'."\n";
						echo '</Response>'."\n";
						echo '</SETICustomers>'."\n";
					}	
					break;
				}
				//Determining the number of products to download
				case "getproductscount" : {
					//$sql = "SELECT COUNT(*) AS productscount FROM ".DB_PREFIX."products";
					//To find max value of the table instead of count fix from ticket ticketid=8950
					$sql = "SELECT MAX(pid) AS productscount FROM ".DB_PREFIX."products"; 
					$db->query($sql);
					$result = $db->moveNext();
					$productscount = $result["productscount"];
					echo "SetiResponse: itemcount=".$productscount;
					break;
				}
				//Downloading Product Data
				case "downloadprods" : {
					$startnum = isset($_REQUEST["startnum"])?($_REQUEST["startnum"]):"";
					$batchsize = isset($_REQUEST["batchsize"])?trim($_REQUEST["batchsize"]):"";
					$dkey = isset($_REQUEST["dkey"])?trim($_REQUEST["dkey"]):"";
					$sql = 
						"SELECT ".DB_PREFIX."products.* ".
						"FROM ".DB_PREFIX."products ".
						"WHERE ".DB_PREFIX."products.pid > 0 ";
					if(is_numeric($startnum)){
						$sql.=" AND ".DB_PREFIX."products.pid >= ".$startnum;
					}
					$sql.=" ORDER BY pid";
					
					if(is_numeric($batchsize)){
						$sql.=" LIMIT ".$batchsize;
					}
					
					$db->query($sql);
					if($db->numRows() > 0){
						echo '<?xml version="1.0"?>'."\n";
						echo '<SETIProducts>'."\n";
						echo '<Response>'."\n";
						echo '<ResponseCode>1</ResponseCode>'."\n";
						echo '<ResponseDescription>success</ResponseDescription>'."\n";
						echo '</Response>'."\n";
						$products = $db->getRecords();
						foreach($products as $product){
							echo '<Product>'."\n";
							echo '<Code>'.$product["product_id"].'</Code>'."\n";
							echo '<WebId>'.$product["pid"].'</WebId>'."\n";
							echo '<Name>'.om_normalize($product["title"]).'</Name>'."\n";
							echo '<Price>'.number_format($product["price"], 2, ".", "").'</Price>'."\n";
							echo '<Cost>'.number_format($product["price"], 2, ".", "").'</Cost>'."\n";
							echo '<Description>'.om_normalize($product["description"]).'</Description>'."\n";
							echo '<Weight>'.number_format($product["weight"], 2, ".", "").'</Weight>'."\n";
							
							//thumb & image
							$thumb = "";
							$image = "";
							if($product["image_location"] == "Web" && $product["image_url"] != ""){
								$thumb = $product["image_url"];
								$image = $product["image_url"];
							}
							else{
								$product_id = strtolower(trim($product["product_id"]));
								for($k=0; $k<strlen($product_id); $k++){
									if(in_array($product_id[$k], array("\\", "/", "*", ":", "?", "<", ">", "|", '"', "'")))$product_id[$k] = "_";
								}
								//thumb
								$tf = "../../../images/products/thumbs/".$product_id.".jpg";
								if(file_exists($tf)){
									$thumb = $global_http_url."/images/products/thumbs/".$product_id.".jpg";
								}
								//image(s)
								if(file_exists("../../../images/products/".$product_id.".png")){
									$image = $global_http_url."/images/products/".$product_id.".png";
								}
								if(file_exists("../../../images/products/".$product_id.".gif")){
									$image = $global_http_url."/images/products/".$product_id.".gif";
								}
								if(file_exists("../../../images/products/".$product_id.".jpg")){
									$image = $global_http_url."/images/products/".$product_id.".jpg";
								}
							}
							
							echo '<Thumb>'.$thumb.'</Thumb>'."\n";
							echo '<Image>'.$image.'</Image>'."\n";
							echo '<Taxable>'.$product["is_taxable"].'</Taxable>'."\n";
							echo '<Discontinued>No</Discontinued>'."\n";
							
							if($product["inventory_control"] == "Yes"){
								$qoh = $product["stock"] > 0 ? $product["stock"] : 0;
							}
							else{
								$qoh = "0";
							}
							
							echo '<QOH>'.$qoh.'</QOH>'."\n";
							
							//options
							$db->query("SELECT * FROM ".DB_PREFIX."products_attributes WHERE pid='".$product["pid"]."' ORDER BY priority");
							if ($db->numRows() > 0)
							{
								echo '<OptionLists>'."\n";
								while (($option = $db->moveNext()) != false)
								{
									echo '<ProductOption>'."\n";
									echo '<WebID>'.$option["paid"].'</WebID>'."\n";
									echo '<Name>'.om_normalize($option["name"]).'</Name>'."\n";
									echo '<Prompt>'.om_normalize($option["caption"]).'</Prompt>'."\n";
									echo '<Type>'.$option["attribute_type"].'</Type>'."\n";
									echo '<Price>0.00</Price>'."\n";
									echo '<Cost>0.00</Cost>'."\n";
									echo '<Image></Image>'."\n";
									echo '<SortOrder>'.$option["priority"].'</SortOrder>'."\n";
									echo '<Required>Yes</Required>'."\n";
									if (in_array($option['attribute_type'], array('select','radio')))
									{
										$optionValues = array();
										if(parseOptions($option["options"], $product["price"], $product["weight"], $optionValues)){
											$sort_order = 1;
											foreach($optionValues as $opt_name=>$opt_value){
												echo '<OptionValue>'."\n";
												echo '<WebID>'.$option["paid"]."-".om_normalize($opt_value["name"]).'</WebID>'."\n";
												echo '<Name>'.om_normalize($opt_value["name"]).'</Name>'."\n";
												echo '<Code>'.om_normalize($opt_value["name"]).'</Code>'."\n";
												echo '<Prompt>'.om_normalize($opt_value["name"]).'</Prompt>'."\n";
												echo '<Price>'.number_format($opt_value["price_difference"], 2, ".", "").'</Price>'."\n";
												echo '<Cost>'.number_format($opt_value["price_difference"], 2, ".", "").'</Cost>'."\n";
												echo '<Weight>'.number_format($opt_value["weight_difference"], 2, ".", "").'</Weight>'."\n";
												echo '<Image></Image>'."\n";
												echo '<SortOrder>'.$sort_order.'</SortOrder>'."\n"; $sort_order++;
												echo '</OptionValue>'."\n";
											}
										}
									}
									
									echo '</ProductOption>'."\n";
								}
								echo '</OptionLists>'."\n";
							}
							echo '</Product>'."\n";
						}
						echo '</SETIProducts>'."\n";
					}
					else{
						echo '<?xml version="1.0"?>'."\n";
						echo '<SETIProducts>'."\n";
						echo '<Response>'."\n";
						echo '<ResponseCode>2</ResponseCode>'."\n";
						echo '<ResponseDescription>success</ResponseDescription>'."\n";
						echo '</Response>'."\n";
						echo '</SETIProducts>'."\n";
					}
					
					break;
				}
				//Downloading Quantity on Hand (Inventory) Data
				case "downloadqoh" : {
					$startnum = isset($_REQUEST["startnum"])?trim($_REQUEST["startnum"]):"";
					$batchsize = isset($_REQUEST["batchsize"])?trim($_REQUEST["batchsize"]):"";
					$sql = 
						"SELECT ".DB_PREFIX."products.* ".
						"FROM ".DB_PREFIX."products ".
						"WHERE ".DB_PREFIX."products.pid>0 ";
					if(is_numeric($startnum)){
						$sql.=" AND ".DB_PREFIX."products.pid >= ".$startnum;
					}
					
					$sql.=" ORDER BY pid";
					
					if(is_numeric($batchsize)){
						$sql.=" LIMIT ".$batchsize;
					}
					
					$db->query($sql);
					if($db->numRows() > 0){
						echo '<?xml version="1.0"?>'."\n";
						echo '<SETIProducts>'."\n";
						echo '<Response>'."\n";
						echo '<ResponseCode>1</ResponseCode>'."\n";
						echo '<ResponseDescription>success</ResponseDescription>'."\n";
						echo '</Response>'."\n";
						while (($product = $db->moveNext()) != false)
						{
							echo '<Product>'."\n";
							echo '<Code>'.om_normalize($product["product_id"]).'</Code>'."\n";
							if ($product["inventory_control"] == "Yes")
							{
								$qoh = $product["stock"] > 0 ? $product["stock"] : 0;
							}
							else
							{
								$qoh = "";
							}
							echo '<QOH>'.$qoh.'</QOH>'."\n";
							echo '</Product>'."\n";
						}
						echo '</SETIProducts>'."\n";
					}
					else{
						echo '<?xml version="1.0"?>'."\n";
						echo '<SETIProducts>'."\n";
						echo '<Response>'."\n";
						echo '<ResponseCode>2</ResponseCode>'."\n";
						echo '<ResponseDescription>success</ResponseDescription>'."\n";
						echo '</Response>'."\n";
						echo '</SETIProducts>'."\n";
					}
					break;
				}
				//Uploading Bulk Inventory Data
				case "qohreplace" : {
					//echo urlencode("4722~10|4880~20");
					$update = isset($_REQUEST["update"])?$_REQUEST["update"]:"";
					$products = explode("|", $update);
					echo 'SETIResponse'."\n";
					for($i=0; $i<count($products); $i++){
						$p = explode("~", $products[$i]);
						$product_id = trim($p[0]);
						$product_stock = intval($p[1]);
						$db->query("SELECT * FROM ".DB_PREFIX."products WHERE product_id='".$db->escape($product_id)."'");
						
						if (($product = $db->moveNext()) != false)
						{
							if($product["inventory_control"] == "Yes"){
								$db->query("UPDATE ".DB_PREFIX."products SET stock='".$product_stock."' WHERE pid='".$product["pid"]."'");
								echo $product_id."=OK\n";
							}
							else{
								echo $product_id."=NA\n";
							}
						}
						else{
							echo $product_id."=NF\n";
						}
					}
					echo 'SETIEndOfData'."\n";
					break;
				}
				//Uploading Individual Inventory Data
				case "invupdate" : {
					$update = isset($_REQUEST["update"])?$_REQUEST["update"]:"";
					$p = explode("~", $update);
					$product_id = trim($p[0]);
					$product_stock = intval($p[1]);
					$db->query("SELECT * FROM ".DB_PREFIX."products WHERE product_id='".$db->escape($product_id)."'");
					if (($product = $db->moveNext()) != false)
					{
						if($product["inventory_control"] == "Yes"){
							$stock = $product["stock"] + $product_stock;
							$db->query("UPDATE ".DB_PREFIX."products SET stock=".$stock." WHERE pid='".$product["pid"]."'");
							echo "SETIRESPONSE=OK;SKU=".$product_id.";QOH=".$stock.";NOTE=";
						}
						else{
							echo "SETIRESPONSE=False;SKU=".$product_id.";QOH=NA;NOTE=NotTracking";
						}
					}
					else{
						echo "SETIRESPONSE=False;SKU=".$product_id.";QOH=NF;NOTE=NotFound";
					}
					break;
				}
			}
		}
		else{
			
			$tod = array_key_exists($setifunction, $setitypes)?$setitypes[$setifunction]:"SetiError";
			
			echo '<?xml version="1.0"?>'."\n";
			echo '<'.$tod.'>'."\n";
			echo '<Response>'."\n";
			echo '<ResponseCode>3</ResponseCode>'."\n";
			echo '<ResponseDescription>Authentification Failed. Please check protocol, username and password.</ResponseDescription>'."\n";
			echo '</Response>'."\n";
			echo '</'.$tod.'>'."\n";
			die();
		}
	}

//plugin class
class plugin_stone_edge_order_manager extends cartPlugin {
	//protected
	var $plugin_id = "stone_edge_order_manager";
	var $plugin_group = "export";
	var $plugin_caption = "Stone Edge Order Manager";
	var $plugin_description = " ";
	
	//constructor
	function plugin_stone_edge_order_manager(){
		return $this;
	}
	
	//run stone edge plugin
	function runPlugin(&$db, &$settings, &$request){
		parent::runPlugin($db, $settings, $request);
		
		//check settings
		if(!array_key_exists("plugin_stone_edge_order_manager_active", $settings)){
			$db->reset();
			$db->assignStr("visible", "No");
			$db->assignStr("input_type", "hidden");
			$db->assignStr("group_name", "plugin_stone_edge_order_manager");
			$db->assignStr("name", "plugin_stone_edge_order_manager_active");
			$db->assignStr("value", "NO");
			$db->assignStr("options", "YES,NO");
			$db->insert(DB_PREFIX."settings");
			$settings["plugin_stone_edge_order_manager_active"] = "NO";
		}
		if(!array_key_exists("plugin_stone_edge_order_manager_username", $settings)){
			$db->reset();
			$db->assignStr("visible", "No");
			$db->assignStr("input_type", "hidden");
			$db->assignStr("group_name", "plugin_stone_edge_order_manager");
			$db->assignStr("name", "plugin_stone_edge_order_manager_username");
			$db->assignStr("value", "");
			$db->insert(DB_PREFIX."settings");
			$settings["plugin_stone_edge_order_manager_username"] = "";
		}
		
		if(!array_key_exists("plugin_stone_edge_order_manager_password", $settings)){
			$db->reset();
			$db->assignStr("visible", "No");
			$db->assignStr("input_type", "hidden");
			$db->assignStr("group_name", "plugin_stone_edge_order_manager");
			$db->assignStr("name", "plugin_stone_edge_order_manager_password");
			$db->insert(DB_PREFIX."settings");
			$db->assignStr("value", "");
			$settings["plugin_stone_edge_order_manager_password"] = "";
		}
		
		//save settings
		if(isset($_REQUEST["action"]) && $_REQUEST["action"] == "update_settings"){
			$db->reset();
			$db->assignStr("value", $_REQUEST["plugin_stone_edge_order_manager_active"]);
			$db->update(DB_PREFIX."settings", "WHERE name='plugin_stone_edge_order_manager_active'");
			$db->reset();
			$db->assignStr("value", $_REQUEST["plugin_stone_edge_order_manager_username"]);
			$db->update(DB_PREFIX."settings", "WHERE name='plugin_stone_edge_order_manager_username'");
			$db->reset();
			$db->assignStr("value", $_REQUEST["plugin_stone_edge_order_manager_password"]);
			$db->update(DB_PREFIX."settings", "WHERE name='plugin_stone_edge_order_manager_password'");
			$settings["plugin_stone_edge_order_manager_active"] = $_REQUEST["plugin_stone_edge_order_manager_active"];
			$settings["plugin_stone_edge_order_manager_username"] = $_REQUEST["plugin_stone_edge_order_manager_username"];
			$settings["plugin_stone_edge_order_manager_password"] = $_REQUEST["plugin_stone_edge_order_manager_password"];
		}
		
		//form header
		pageHeader("Stone Edge Order Manager Export");
		pageNote(array(
			array("icon"=>"ic_hint.gif", "text"=>"This area will export data to Stone Edge Order Manager. For more information regarding Stone Edge, <a href=\"http://www.stoneedge.com\">http://www.stoneedge.com</a><br>Please enter access informaiton below.", "visible"=>true),
			array("icon"=>"ic_hint.gif", "text"=>"Connection URL is ".$settings["GlobalHttpsUrl"]."/content/admin/plugins/stone_edge_order_manager/plugin.stone_edge_order_manager.php", "url"=>"", "visible"=>true)
		));
		
		//form table
		
		pageTabs(array(array("title"=>"Plugin Settings", "id"=>"Main", "active"=>true, "width"=>140)));
		echo '<div id="idTabSheetMain" class="sheetActive" style="padding:0px;margin:0px;">';
		echo '<form name="frmPlugin" action="admin.php?p=plugin&plugin_id='.$this->plugin_id.'" method="POST" style="padding:0px;spacing:0px;margin:0px;">';
		echo '<table width="100%" cellpadding="0" cellspacing="5" border="0">';
		echo '<input type="hidden" name="action" value="update_settings">';
		
		echo '<tr><td class="formHeader" colspan="2"><div class="formHeaderIcon"><img src="images/icons/ic_settings.gif"/></div><div class="formHeaderText">Stone Edge Order Manager Settings</div></td></tr>';
		
		echo '<tr valign="top"><td class="formItemCaption">Enable Stone Edge Order Manager Export?</td>';
		echo '<td class="formItemControl">';
		echo '<select name="plugin_stone_edge_order_manager_active" style="width:123px;">';
		echo '<option value="YES">Yes</option>';
		echo '<option value="NO" '.($settings["plugin_stone_edge_order_manager_active"]=="NO"?"selected":"").'>No</option>';
		echo '</select><div class="formItemComment">Selecting NO will disable export. Authentification failed message will be returned.</div>';
		echo '</td></tr>';
		
		echo '<tr valign="top"><td class="formItemCaption">Username</td>';
		echo '<td class="formItemControl">';
		echo '<input type="text" style="width:250px;" name="plugin_stone_edge_order_manager_username" value="'.htmlspecialchars($settings["plugin_stone_edge_order_manager_username"]).'">';
		echo '</td></tr>';
		
		echo '<tr valign="top"><td class="formItemCaption">Password</td>';
		echo '<td class="formItemControl">';
		echo '<input type="text" style="width:250px;" name="plugin_stone_edge_order_manager_password" value="'.htmlspecialchars($settings["plugin_stone_edge_order_manager_password"]).'">';
		echo '</td></tr>';
		
		echo '</table></div>';
		
		echo '<div class="formButtons">';
		echo '<input type="image" src="images/admin/bt_save_changes.gif"> &nbsp;';
		echo '<input type="image" src="images/admin/bt_reset_form.gif" onClick="frmPlugin.reset();return false;">';
		echo '</div>';
		
		echo '</form>';
			
	}//end of runPlugin procedure
}//end of class
?>