<?php
if(!class_exists("DobaAPI")) require_once("content/classes/class.doba.php");
if(!class_exists("DobaProductAPI")) require_once("content/classes/class.doba_product.php");
if(!class_exists("DobaOrderAPI")) require_once("content/classes/class.doba_order.php");
if(!class_exists("DobaRetailerAPI")) require_once("content/classes/class.doba_order.php");

/**
 * Doba Product API Class
 */
class DobaCallbackAPI extends DobaAPI 
{
	/**
	 * Parses Doba callback request
	 * @param string $xml
	 * @return mixed
	 */
	public function processCallback($xml)
	{
		$xmlParser = new XMLParser();
		$parsed = $xmlParser->parse($xml);
		
		if ($parsed && isset($parsed["dce"][0]["response"][0]["callback_type"][0]))
		{
			$callback_type = $parsed["dce"][0]["response"][0]["callback_type"][0];
			
			$productApi = new DobaProductAPI($this->_settings, $this->_db);
			
			switch ($callback_type)
			{
				/**
				 * Update items details
				 */
				case "item_detail" :
				{
					foreach ($parsed["dce"][0]["response"][0]["items"][0]["item"] as $item)
					{
						$productApi->itemToDb($item, false);
					}
					break;		
				}
				
				/**
				 * Update inventory
				 */
				case "inventory_update" :
				{
					foreach ($parsed["dce"][0]["response"][0]["items"][0]["item"] as $item)
					{
						$productApi->updateInventory($item, false);
					}
					break;		
				}
			}
			
			updateSeoURLs($this->_db, $this->_settings, true, true, false);
			
			unset($productApi);
		}
		
		unset($xmlParser);
	} 
}