<?php
/**
 * Complete order
 */

if (!defined("ENV")) exit();

if ($user->auth_ok && $order->itemsCount)
{
	$order->recalcOrderData();
	// *** GIFT CERTIFICATE
	$gift_cert_amount = 0;
	$payment_status = "Pending";
	$total_amount = $order->totalAmount; //-$order->shippingAmount-$order->taxAmount-($order->handlingSeparated?$order->handlingAmount:0.00);
		
	if ($total_amount > 0)
	{
		$gift_cert = new GiftCertificates($db);
		$order_data = $gift_cert->GetOrderGiftCert($order->oid);
		if ($order_data['gift_cert_valid'] == '1')
		{
			$gift_data = $gift_cert->GetOrderedGiftCert($order_data['gift_cert_first_name'], $order_data['gift_cert_last_name'], $order_data['gift_cert_voucher']);
			if ($gift_data !== false)
			{
				$balance = $gift_data['balance'];
				if ($total_amount > $balance)
				{
					$gift_cert_amount = $balance;
					$gift_cert->UpdateBalance($order->oid, $gift_data['ocid'], $balance);
				} 
				else
				{
					$payment_status = "Received";
					$gift_cert_amount = $total_amount;
					$gift_cert->UpdateBalance($order->oid, $gift_data['ocid'], $total_amount);
				}
			}
		}
	}
	
	if ($gift_cert_amount > 0)
	{
		$db->reset();
		$db->assignStr("payment_method_name", "Gift Certificate");
		$db->assignStr("payment_gateway_id", "");
		$db->update(DB_PREFIX."orders", "WHERE oid='".$order->oid."'");
		view()->assign("payment_method_name", "Gift Certificate");
	}
	view()->assign("gift_cert_amount", $gift_cert_amount);
	// *** GIFT CERTIFICATE
	// fix for http://dev.pinnaclecart.com/mantis/view.php?id=76
	if ($order->totalAmount == 0)
	{
		$payment_status = "Received";
		// *** GIFT CERTIFICATE
		// fix for http://dev.pinnaclecart.com/mantis/view.php?id=480
		$gift_cert = new GiftCertificates($db);
		$gift_data = $gift_cert->GetGiftCertificate($order->oid);
		if ($gift_data !== false)
		{
			// the user has ordered a gift certificate
			$gift_cert->OrderGiftCertificate($gift_data['ocid'], $gift_data['first_name'], $gift_data['last_name'], $gift_data['gift_amount'], $gift_data['voucher']);
			if ($gift_data['email_gift'] == '1')
			{
				$gift_cert->SendNotification($order->oid);
			}
		}	
	}
	
	$order->order_num = $order->closeOrder("Process", $payment_status);
	
	if (($settings["InventoryStockUpdateAt"]=="Payment Received" && $payment_status == "Received") || $settings["InventoryStockUpdateAt"]=="Order Placed")
	{
		$order->stockControl(); //do not process stock without payment
	}

	///////////////////////////////////////
	// BUY SAFE
	if ($settings["buysafe_active"] == "Yes")
	{
		$buysafe = new BuySafeAPI($settings);
		$result = $buysafe->setShoppingCartCheckout($user, $order, $db);
	}
		
	///////////////////////////////////////
	// DOBA
	if (isset($_SESSION["doba_items_in_order"]) && $_SESSION["doba_items_in_order"] && $settings["doba_autosend_orders"] == "Yes")
	{
		$doba_items = array();
		foreach ($order->items as $item)
		{
			if ($item["is_doba"] == "Yes") $doba_items[] = array("item_id"=>$item["product_id"], "quantity"=>$item["quantity"]);
		}
		
		if (count($doba_items) > 0)
		{
			require_once("content/classes/class.doba_order.php");
			$dobaOrder = new DobaOrderAPI($settings, $db);
			
		 	$doba_order_response = $dobaOrder->createOrder($order->shippingAddress, $doba_items);
		 	
		 	if ($doba_order_response)
		 	{
		 		$db->query("UPDATE ".DB_PREFIX."orders SET doba_order_sent=1, doba_order_id='".$db->escape($doba_order_response["order_id"][0])."' WHERE oid='".$order->oid."'");
		 	}
		}
	}
	unset($_SESSION["doba_items_in_order"]);
	
	
	/////////////////////////////////////
	// Email notifications
	emailOrderReceived($db, $order, $user, $custom_fields, $payment_status);
		
	/////////////////////////////////////
	// Complete order
	$payment_method_id = $order->paymentMethodId;
		
	$backurl = $url_dinamic."p=completed";
		
	unset($_SESSION["payment_session_delay_timeout"]);
}
