<?php
	/**
	 * Check Design Mode
	 */
	if (isset($_SESSION['admin_auth_id']) && $_SESSION['admin_auth_id'] && isset($_SESSION['admin_design_mode']) && $_SESSION['admin_design_mode'])
	{
		require_once("content/classes/class.ddm_design_mode.php");
		
		$designMode = new Ddm_Design_Mode($settings);
		
		view()->assign('isAdmin', true);
		view()->assign('isDesignMode', true);
		view()->assign('designSkinThemes', $s = $designMode->getSkinThemes());
		
		// Read the contents of the styles and themes directory for display
		// FIXME: Save this into cache folder the way we do languages
		$designStylesheets = array(
			'styles' => array(),
			'themes' => array()
		);
		
		$template_directory = 'content/skins/'.$settings['DesignSkinName'].'/';
		
		if (($fh = opendir($template_directory)) !== false)
		{
			while (($file = readdir($fh)) !== false)
			{
				if (is_dir($template_directory.$file) && in_array($file, array('styles')))//, 'themes')))
				{
					if (($folder = opendir($template_directory.$file)) !== false)
					{
						while (($stylesheet = readdir($folder)) !== false)
						{
							if (!in_array($stylesheet, array('.', '..', '.svn')) && substr($stylesheet, -4) == '.css')
								$designStylesheets[$file][] = $stylesheet;
						}
						closedir($folder);
					}
				}
			}
			closedir($fh);
		}
		
		view()->assign('designStylesheets', $designStylesheets);
		
		$action = isset($_REQUEST["action"]) ? $_REQUEST["action"] : "";
		
		switch($action)
		{
			case "loadElement" : 
			{
				$doRender = false;
				if (isset($_REQUEST['class']))
				{
					$templateFile = "templates/".str_replace('_', '/', substr($_REQUEST['class'], 8)).'.html';
					//die("Fetching $templateFile");
					if (is_file(view()->templateDir().$templateFile))
					{
						$html = view()->fetch($templateFile);
						$response = array("status" => 1, "html" => $html);
					}
					else
					{
						$response = array("status" => 0, "message" => "Cannot load element.\n".view()->templateDir().$templateFile." file does not exist.\nPlease check permissions");
					}
				}
				else
				{
					$response = array("status" => 0, "message" => 'Error Loading Data');
				}
				echo json_encode($response);
				break;		
			}
		}
		//assemble each time while in design mode
		/**
		view()->assemble(
			array(
				'content/engine/design', 
				'content/skins/'.escapeFileName($settings['DesignSkinName']),
				'content/skins/_custom/skin',
			), 
			'content/cache/skins/'.escapeFileName($settings['DesignSkinName'])
		);
		**/
	}