<?php
	$google_xml = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : file_get_contents("php://input");

	//load class, create xml parser and parse xml
	require_once("./../../../classes/class.xml.php");
	$xmlParser = new XMLParser();
	$parsed_result = $xmlParser->parse($google_xml);
	
	require_once("./../../../engine/engine_config.php");
	require_once("./../../../engine/engine_label.php");
	require_once("./../../../engine/engine_mysql.php");
	
	require_once("./../../../engine/engine_functions.php");
	require_once("./../../../engine/engine_ups.php");
	require_once("./../../../classes/class.gift_certificates.php");
	
	$db = new DB;
	$db->init(DB_HOST, DB_USER, DB_PASSWORD, DB_NAME);
	
	require_once("./../../../engine/engine_settings.php");
	
	// load localization procedures
	require_once("./../../../engine/engine_localization.php");

	// load mod_rewrite libraries
	require_once("./../../../engine/engine_url_".($settings["USE_MOD_REWRITE"]=="YES"?"rewrite":"default").".php");

	require_once("./../../../engine/engine_user.php");
	require_once("./../../../engine/engine_order.php");
	require_once("./../../../engine/engine_shipping.php");

	$pcsid = isset($_REQUEST["pcsid"])?$_REQUEST["pcsid"]:"";
	if (ereg("[0-9a-zA-Z]{1,}", $pcsid))
	{
		session_id($pcsid);
	}
	//start session
	$session_dir = $settings["GlobalServerPath"]."/content/cache/sessiondata";
	if(is_dir($session_dir) && is_writable($session_dir)){
		ini_set("session.save_path", $session_dir);
	}
	session_set_cookie_params($settings["SecurityUserTimeout"]);
	session_cache_expire(round($settings["SecurityUserTimeout"]/60)); // 24 hours
	session_name("ShoppingCartSession");
	session_start();
	
	$_SESSION["google_checkout_used"] = true;
	
	//get default currency code
	$db->query("SELECT code FROM ".DB_PREFIX."currencies WHERE is_default='Yes'");
	$currency_code = $db->moveNext() ? $db->col["code"] : "USD";
			
	//reinit users and orders
	$user = new USER($db, $settings);
	
	if(!$user->auth_ok){
		$user->ExpressLogin();
	}
	
	$order = new ORDER($db, $settings, $user, true);
	
	//update payment method to google
	$db->query("SELECT pid FROM ".DB_PREFIX."payment_methods WHERE id='googlecheckout'");
	$db->moveNext();
	$payment_method_id = $db->col["pid"];
	$order->updatePaymentMethod($payment_method_id);
	
	
	if($user->auth_ok && $settings["TaxAddress"] != "Default"){
		if($settings["TaxAddress"] == "Billing"){
			$order->taxCountryId = $user->data["country"];
			$order->taxStateId = $user->data["state"];
		}
		$order->checkShippingDigital();
		if($settings["TaxAddress"] == "Shipping" && !$order->shippingDigital && $order->oid > 0 && $order->oid != ""){
			$sa = $order->getShippingAddress();
			if($sa && $order->shippingAddress["country_id"] > 0){
				$order->taxCountryId = $sa["country_id"];
				$order->taxStateId = $sa["state_id"];
			}
		}
	}
	// select order data first time before possible modification
	$order->getOrderData();
	$order->getOrderItems();
	$order->getTaxRates();

	//update amounts
	$subtotal_amount = 0;
	$shipping_amount = 0;
	$handling_amount = 0;
	$tax_amount = 0;
	//set additional shipping params
				
	$shipping_price_at_product_level = 0;
	$shipping_amount_for_price_based = 0;
	$shipping_amount_for_price_based_exists = false;
	$shipping_weight = 0;
	$shipping_items_count = 0;
	$shipping_price_dollar_days = 0;
	$shipping_digital = 1;
	$db->query("SELECT * FROM ".DB_PREFIX."orders_content WHERE oid='".$order->oid."'");
	
	while($db->moveNext()){
		if($db->col["digital_product"] == "No"){
			$shipping_digital = 0;
		}
		//calc vars for shipping
		if($db->col["is_dollar_days"] == "Yes"){
			$shipping_price_dollar_days = $shipping_price_dollar_days + $db->col["admin_price"] * $db->col["admin_quantity"];
		}
		else{
			if($db->col["is_shipping_price"] == "Yes" && $db->col["free_shipping"] == "No" && $db->col["digital_product"] == "No"){
				$shipping_price_at_product_level = $shipping_price_at_product_level + $db->col["shipping_price"] * $db->col["admin_quantity"];
				$order_content_shipping_price[$db->col["ocid"]] = array("is_shipping_price"=>"Yes", "shipping_price"=>$db->col["shipping_price"]);
			}
			if($db->col["is_shipping_price"] == "No" && $db->col["free_shipping"] == "No" && $db->col["digital_product"] == "No"){
				$shipping_items_count = $shipping_items_count + $db->col["admin_quantity"];
				$shipping_weight = $shipping_weight + $db->col["weight"] * $db->col["admin_quantity"];
				$shipping_amount_for_price_based = $shipping_amount_for_price_based + $db->col["admin_price"] * $db->col["admin_quantity"];
				$shipping_amount_for_price_based_exists = true;
			}
		}
			
		//subtotal amount
		$subtotal_amount = $subtotal_amount + ($db->col["admin_price"] * $db->col["admin_quantity"]);
	}
	
	$a = array_keys($parsed_result);
	$recognized_request = is_array($a) && array_key_exists(0, $a) ? $a[0] : "none";
	
	switch($recognized_request){
		
		//////////////////////////////////////
		// PROCESS MERCHANT CALC CALLBACK
		case "merchant-calculation-callback" : {
			//build google response
			$result_xml = 
				'<?xml version="1.0" encoding="UTF-8"?>'.
				'<merchant-calculation-results xmlns="http://checkout.google.com/schema/2">'.
					'<results>';
			///debuging code
					
			if(isset($parsed_result["merchant-calculation-callback"][0]["calculate"][0]["shipping"][0])){
				//get existing shipping methods
				$selected_shipping_methods = array();
				$db->query("SELECT * FROM ".DB_PREFIX."shipping_selected ORDER BY priority");
				while($db->moveNext()){
					$shipping_method_name = $db->col["carrier_name"].($db->col["carrier_id"] != "custom" ? " ".$db->col["method_name"] : "");
					$selected_shipping_methods[$shipping_method_name] = $db->col; 
					$selected_shipping_methodsID[$shipping_method_name] = $db->col["method_id"]	;				
				}
				
				
				//set initial params
				$db->query("SELECT * FROM ".DB_PREFIX."countries WHERE coid='".$settings["ShippingOriginCountry"]."'");
				if($db->moveNext()){
					$address_from = array("country" => $db->col["name"], "country_iso_a2" => $db->col["iso_a2"], "country_iso_a3" => $db->col["iso_a3"], "country_iso_number"=>$db->col["iso_number"], "zip" => $settings["ShippingOriginCountry"]=="1"?substr(trim($settings["ShippingOriginZip"]), 0, 5):trim($settings["ShippingOriginZip"]));
				}
				else{
					$address_from = array("country" => "United States", "country_iso_a2" => "US", "country_iso_a3" => "USA", "country_iso_number"=>"840",  "zip" => $settings["ShippingOriginCountry"]=="1"?substr(trim($settings["ShippingOriginZip"]), 0, 5):trim($settings["ShippingOriginZip"]));
				}
				
				$shipping_addresses = $parsed_result["merchant-calculation-callback"][0]["calculate"][0]["addresses"][0]["anonymous-address"];
				$shipping_methods = $parsed_result["merchant-calculation-callback"][0]["calculate"][0]["shipping"][0]["method@"];
				
				$tax_recalc = isset($parsed_result["merchant-calculation-callback"][0]["tax"])?$parsed_result["merchant-calculation-callback"][0]["tax"][0]:"false";
				
				foreach($shipping_addresses as $shipping_address_key=>$shipping_address){
					$address_id = $parsed_result["merchant-calculation-callback"][0]["calculate"][0]["addresses"][0]["anonymous-address@"][$shipping_address_key]["id"];
					
					//parse address information
					//get country info
					

					$db->query("SELECT * FROM ".DB_PREFIX."countries WHERE iso_a2='".$shipping_address["country-code"][0]."'");
					$address_country_data = $db->moveNext()?$db->col:array("coid"=>1, "name"=>"Unated States", "iso_a2"=>"US", "iso_a3"=>"USA", "iso_number"=>"840");
					
					//get state info
					$db->query("SELECT * FROM ".DB_PREFIX."states WHERE short_name='".$shipping_address["region"][0]."'");
					$address_state_data = $db->moveNext()?$db->col:array("stid"=>"0", "name"=>"California", "short_name"=>"CA");
					
					//get order tax 
					$tmp_shipping_address = array(
											
						"name" => "Google Anonymous",
						"company" => "",
						"address1" => "Google Anonymous Address",
						"address2" => "",
						"city" => $shipping_address["city"][0],
						"state" => $address_state_data["stid"],
						"province" => $shipping_address["region"][0],
						"country" => $address_country_data["coid"],
						"zip" => $shipping_address["postal-code"][0]
					);
					$tp = $tmp_shipping_address["country"];
					
					$order->updateShippingAddress($tmp_shipping_address);
					$order->taxCountryId = $address_country_data["coid"];
					$order->taxStateId = $address_state_data["stid"];
					$order->getTaxRates();
					$order->reupdateItems();
					
					foreach($shipping_methods as $shipping_method_key=>$shipping_method){
									
						$shipping_method_name = $parsed_result["merchant-calculation-callback"][0]["calculate"][0]["shipping"][0]["method@"][$shipping_method_key]["name"];
						
						$order->shippingSSID = $selected_shipping_methods[$shipping_method_name]["ssid"];
						$order->shippingMethodID = $selected_shipping_methodsID[$shipping_method_name];

						$error_message = "";						
						$order->getShippingAmount($error_message);
						
						if($error_message == ""){
							$shippable = true;
							$order->getTaxRates();
							$order->getTaxAmount();
						}
						else{
							$shippable = false;
						}
						$result_xml.='<result shipping-name="'.htmlspecialchars($shipping_method_name).'" address-id="'.htmlspecialchars($address_id).'">';
						$result_xml.='<shipping-rate currency="'.$currency_code.'">'.number_format($order->shippingAmount, 2, ".", "").'</shipping-rate>';
						//if($tax_recalc == "true"){
						$result_xml.='<total-tax currency="'.$currency_code.'">'.number_format($order->taxAmount, 2, ".", "").'</total-tax>';
						//}
						$result_xml.='<shippable>'.($shippable?"true":"false").'</shippable>';
						$result_xml.='</result>';

					}
					
				}
			}
			
			$result_xml .=
					'</results>'.
				'</merchant-calculation-results>';
			//simple log
			echo $result_xml;
			break;
		}
	}
	session_write_close();
	$db->done();
