<?php 
	$payment_processor_id = "moneybookersewallet";
	$payment_processor_name = "moneybookersewallet";
	$payment_processor_version = "2.0";
	$payment_processor_class = "PAYMENT_MONEYBOOKERSEWALLET";
	$payment_processor_type = "ipn";
	
	class PAYMENT_MONEYBOOKERSEWALLET extends PAYMENT_PROCESSOR{
		function PAYMENT_MONEYBOOKERSEWALLET(){
			parent::PAYMENT_PROCESSOR();
			$this->id = "moneybookersewallet";
			$this->name = "moneybookersewallet";
			$this->version = "2.0";
			$this->class_name = "PAYMENT_MONEYBOOKERSEWALLET";
			$this->type = "ipn";
			$this->description = "";
			$this->post_url = "";
			$this->steps = 2;
			$this->possible_payment_delay = true;
			$this->possible_payment_delay_timeout = 10; // seconds
			return $this;
		}
		
		//redeclare getPaymentForm
		function getPaymentForm($db){
			global $_SESSION;
			global $settings, $order, $url_dinamic;
			global $msg;
			
			$_pf = parent::getPaymentForm($db);
			
			$notify_url = ($this->protocol=="https"?$settings["GlobalHttpsUrl"]:$settings["GlobalHttpUrl"])."/".$settings["INDEX"]."?pcsid=".session_id()."&p=".$this->payment_page."&oa=ProcessPayment";
			$return_url = $url_dinamic."?pcsid=".session_id()."&p=completed&oa=ProcessPayment&transaction_id=".$this->common_vars["order_id"]["value"];
		
			$status_url = ($this->protocol=="https"?$settings["GlobalHttpsUrl"]:$settings["GlobalHttpUrl"])."/".$settings["INDEX"]."?pcsid=".session_id()."&p=completed&oa=ProcessPayment&transaction_id=".$this->common_vars["order_id"]["value"];
			
			if($settings["GlobalHttpsUrl"])
				$logo_url=$settings["GlobalHttpsUrl"]."/images/admin/logo.gif";

			// wmw 04/05/05 Added to get phone number fields for Moneybookers
			if ($this->common_vars["billing_country_iso_a2"]["value"] == "US") {
				$pp_phone = ereg_replace("[-\(\)\. ]","",$this->common_vars["billing_phone"]["value"]);
				$pp_phone_a = substr($pp_phone,0,3);
				$pp_phone_b = substr($pp_phone,3,3);
				$pp_phone_c = substr($pp_phone,6,4);
			} 
			else {
				$pp_phone_a = "";
				$pp_phone_b = "";
				$pp_phone_c = "";
			}
			// END wmw 04/05/05
				
			
		 $fields = array();
			// added by yogendra mishra
			$fields[] = array("type"=>"hidden", "name"=>"payment_methods", "value"=>"WLT");
			$fields[] = array("type"=>"hidden", "name"=>"hide_login", "value"=>"1");
			$fields[] = array("type"=>"hidden", "name"=>"merchant_fields", "value"=>"referring_platform");
			$fields[] = array("type"=>"hidden", "name"=>"referring_platform", "value"=>"pinnacle_cart");
			$fields[] = array("type"=>"hidden", "name"=>"return_url_target", "value"=>"1");
			$fields[] = array("type"=>"hidden", "name"=>"cancel_url_target", "value"=>"1");
			//end here
			$fields[] = array("type"=>"hidden", "name"=>"pay_to_email", "value"=>$this->settings_vars[$this->id."_email_id"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"customer_id", "value"=>$this->settings_vars[$this->id."_customer_id"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"secret_word", "value"=>md5($this->settings_vars[$this->id."_secret_word"]["value"]));
			$fields[] = array("type"=>"hidden", "name"=>"language", "value"=>$this->settings_vars[$this->id."_language"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"recipient_description", "value"=>$settings["CompanyName"]);
			
			$fields[] = array("type"=>"hidden", "name"=>"item_name", "value"=>$settings["CompanyName"].' Order #'.$this->common_vars["order_id"]["value"]); 
			$fields[] = array("type"=>"hidden", "name"=>"transaction_id", "value"=>$this->common_vars["order_id"]["value"]);
			
			$fields[] = array("type"=>"hidden", "name"=>"firstname", "value"=>$this->common_vars["billing_first_name"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"lastname", "value"=>$this->common_vars["billing_last_name"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"address", "value"=>$this->common_vars["billing_address1"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"address2", "value"=>$this->common_vars["billing_address2"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"phone_number", "value"=>$this->common_vars["billing_phone"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"postal_code", "value"=>$this->common_vars["billing_zip"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"city", "value"=>$this->common_vars["billing_city"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"state", "value"=>$this->common_vars["billing_state"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"country", "value"=>$this->common_vars["billing_country_iso_a3"]["value"]);
			
			$fields[] = array("type"=>"hidden", "name"=>"amount", "value"=>round($this->common_vars["order_total_amount"]["value"], 2));
			$fields[] = array("type"=>"hidden", "name"=>"currency", "value"=>$this->settings_vars[$this->id."_currency_code"]["value"]);
			
			// $fields[] = array("type"=>"hidden", "name"=>"paymentaction", "value"=>strtolower($this->settings_vars[$this->id."_Payment_Action"]["value"]));
			
			$fields[] = array("type"=>"hidden", "name"=>"quantity", "value"=>"1");
			$fields[] = array("type"=>"hidden", "name"=>"logo_url", "value"=>$logo_url);
			$fields[] = array("type"=>"hidden", "name"=>"status_url2", "value"=>'mailto:'.$this->settings_vars[$this->id."_status_url2"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"invoice", "value"=>$this->common_vars["order_id"]["value"]);
			$fields[] = array("type"=>"hidden", "name"=>"pay_from_email", "value"=>$this->common_vars["billing_email"]["value"]);
			
			$fields[] = array("type"=>"hidden", "name"=>"notify_version", "value"=>"2.0");
			$fields[] = array("type"=>"hidden", "name"=>"status_url", "value"=>$status_url);
			$fields[] = array("type"=>"hidden", "name"=>"return_url", "value"=>$return_url);
			
			$fields[] = array("type"=>"hidden", "name"=>"cancel_url", "value"=>(($this->protocol=="https"?$settings["GlobalHttpsUrl"]:$settings["GlobalHttpUrl"])."/".$settings["INDEX"]."?pcsid=".session_id()."&p=".$this->payment_page));
			$itemname = $this->common_vars["order_id"]["value"];
				
			$getvalues="https://www.moneybookers.com/app/payment.pl?pay_to_email=".$this->settings_vars[$this->id."_email_id"]["value"]."&currency=".$this->settings_vars[$this->id."_currency_code"]["value"]."&amount=".round($this->common_vars["order_total_amount"]["value"], 2)."&payment_methods=WLT&hide_login=1&merchant_fields=referring_platform&referring_platform=pinnacle_cart&return_url_target=1&cancel_url_target=1&language=".$this->settings_vars[$this->id."_language"]["value"]."&recipient_description=".$settings["CompanyName"]."&transaction_id=".$this->common_vars["order_id"]["value"]."&firstname=".$this->common_vars["billing_first_name"]["value"]."&lastname=".$this->common_vars["billing_last_name"]["value"]."&address=".$this->common_vars["billing_address1"]["value"]."&address2=".$this->common_vars["billing_address2"]["value"]."&phone_number=".$this->common_vars["billing_phone"]["value"]."&city=".$this->common_vars["billing_city"]["value"]."&state=".$this->common_vars["billing_state"]["value"]."&country=".$this->common_vars["billing_country_iso_a3"]["value"]."&quantity=1&logo_url=".$logo_url."&status_url2="."mailto:".$this->settings_vars[$this->id."_status_url2"]["value"]."&invoice=".$this->common_vars["order_id"]["value"]."&pay_from_email=".$this->common_vars["billing_email"]["value"]."&notify_version=2.0&status_url=".$status_url."&return_url=".$return_url."&cancel_url=".(($this->protocol=="https"?$settings["GlobalHttpsUrl"]:$settings["GlobalHttpUrl"])."/".$settings["INDEX"]."?pcsid=".session_id()."&p=".$this->payment_page);
			
			$fields[] = array("type"=>"hidden", "name"=>"moneybookersiframeval", "value"=>$getvalues); 
			
			return $fields; 
			/*	
			$getvalues='pay_to_email='.$this->settings_vars[$this->id."_email_id"]["value"].'&currency='.$this->settings_vars[$this->id."_currency_code"]["value"].'&amount='.round($this->common_vars["order_total_amount"]["value"], 2);
			
	$moneybookersiframe="<IFRAME SRC=https://www.moneybookers.com/app/payment.pl?".$getvalues." WIDTH=600 HEIGHT=800 FRAMEBORDER=0></IFRAME>";
			
			return $moneybookersiframe;*/
		}
		
		function getValidatorJS(){
			return "";
		}
		
		function isTestMode(){
			return '';
		}
		
		function isMoneyBookers()
		{
			return true;
		}
		
		function getPostUrl(){
			if(trim($this->url_to_gateway) != ""){
				return trim($this->url_to_gateway);
			}
			else{
				return $this->post_url;
			}
		}
		
		function process($db, $user, $order, $post_form){
			global $_POST;
			global $settings;
			
			//check payment status				
			if((trim(strtolower($post_form["status"])) == "2") || (trim(strtolower($post_form["status"])) == "0")){
				
				//reinsure all is OK - verify request
				$post_data = 'cmd=_notify-validate';
				reset($post_form);
				foreach($_POST as $var_name=>$var_value){
					$post_data .= "&".$var_name."=".urlencode($var_value);
				}
						
				//https://www.moneybookers.com
				$this->post_url = $this->getPostUrl();
				//check verification value
				if((trim(strtolower($post_form["status"])) == "2") || (trim(strtolower($post_form["status"])) == "0") ){
					reset($post_form);
					//$response = "Verification Status: ".$buffer."\n";
					foreach($post_form as $var_name=>$var_value){
						$response.=$var_name." = ".$var_value."\n";
						error_log($response);
						if($var_name == "transaction_id")
							$transaction_id = $var_value;
						if($var_name == "status")
							$payment_status = $var_value;	
						if((trim(strtolower($post_form["status"])) == "0"))	
							$PendingReason = 'This status is sent when the customers pays via the pending bank transfer option - Moneybookers.';
					}					
					$this->createTransaction($db, $user, $order, $response, "", $PendingReason, "", 0, $transaction_id);
					$this->is_error = false;
					$this->error_message = "";
					return $payment_status;
				}
				else{
					$this->is_error = true;
					$this->error_message = "Can't complete your order. MoneyBookers payment is not completed yet.";
				}
			
				

			return !$this->is_error;
		}
	}
}
?>
