<?php
	$payment_processor_id = "payjunction";
	$payment_processor_name = "PayJunction";
	$payment_processor_version = "1";
	$payment_processor_class = "PAYMENT_PAYJUNCTION";
	$payment_processor_type = "cc";

	class PAYMENT_PAYJUNCTION extends PAYMENT_PROCESSOR{
		function PAYMENT_PAYJUNCTION(){
			parent::PAYMENT_PROCESSOR();
			$this->id = "payjunction";
			$this->name = "PayJunction";
			$this->version = "3.3";
			$this->class_name = "PAYMENT_PAYJUNCTION";
			$this->type = "cc";
			$this->description = "";
			$this->steps = 1;
			$this->testMode = false;
			//$this->url_to_gateway = "https://payjunction.com/quick_link";
			return $this;
		}	

		function getPaymentForm($db){
			$fields = parent::getPaymentForm($db);
			return $fields;
		}
	
		function isTestMode(){
			if($this->settings_vars[$this->id."_dc_test_request"]["value"] == "TRUE"){
				$this->testMode = true;
			}
			else{
				$this->testMode = false;
			}
			return $this->testMode;
		}
	
		function process($db, $user, $order, $post_form){
			$post_array = array(		
				"dc_logon" => $this->settings_vars[$this->id."_dc_logon"]["value"],		
				"dc_password" => $this->settings_vars[$this->id."_dc_password"]["value"],		
				"dc_transaction_amount" => $this->common_vars["order_total_amount"]["value"],		
				"dc_first_name" => $post_form["cc_first_name"],		
				"dc_last_name" => $post_form["cc_last_name"],		
				"dc_number" => $post_form["cc_number"],		
				"dc_expiration_month" => $post_form["cc_expiration_month"],		
				"dc_expiration_year" => $post_form["cc_expiration_year"],		
				"dc_verification_number" => $post_form["cc_cvv2"],		
				"dc_address" => $this->common_vars["billing_address1"]["value"]." ".$this->common_vars["billing_address2"]["value"],		
				"dc_city" => $this->common_vars["billing_city"]["value"],		
				"dc_state" => $this->common_vars["billing_state"]["value"],		
				"dc_zipcode" => $this->common_vars["billing_zip"]["value"],		
				"dc_country" => "US",		
				"dc_transaction_type" => $this->settings_vars[$this->id."_dc_transaction_type"]["value"],		
				"dc_test" => "No",		
				"dc_version" => "1.2"		
			);
			$request = "";
			
			foreach ($post_array as $key => $val) {		
				$request .= $key . "=" . urlencode($val) . "&";		
			}
			$request = substr($request, 0, -1);
			$_post_url = trim($this->url_to_gateway)==""?"https://payjunction.com/quick_link":trim($this->url_to_gateway);
			$ch = curl_init($_post_url);

			curl_setopt($ch, CURLOPT_POST, 1);		
			curl_setopt($ch, CURLOPT_POSTFIELDS, $request);		
			curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 0);		
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
			
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
			curl_setopt($ch, CURLOPT_CAPATH, $settings['GlobalServerPath'].$settings['SecuritySslDirectory']);
			curl_setopt($ch, CURLOPT_CAINFO, $settings['GlobalServerPath'].$settings['SecuritySslDirectory'].'/'.$settings['SecuritySslPem']);
			$content = curl_exec($ch);
			$curl_errno = curl_errno($ch);
			$curl_error = curl_error($ch);
			if(isset($curl_errno)) $this->error_message = $curl_errno.":-".$curl_error;
			curl_close($ch);
			$res=$content;
			$content = explode(chr (28), $content); // The ASCII field seperator character is the delimiter
			
			foreach ($content as $key_value) {		
				list ($key, $value) = explode("=", $key_value);			
				$response[$key] = $value;
			}
			if (strcmp ($response['dc_response_code'], "00") == 0 || strcmp ($response['dc_response_code'], "85") == 0) {
				$this->createTransaction($db, $user, $order, $res, "");
				$this->is_error = false;
				$this->error_message = "";
				//echo "Success!";
			}else{
				$this->error_message.= $response['dc_response_code'];			
				$this->logStart();
				$this->log($response);
				$this->log($this->error_message);
				$this->logFinish();
				$this->is_error = true;
				//echo "Failed.".$response['dc_response_code'];
			}
			return !$this->is_error;		
		}
	}
