<?php
/**
 * Billing and shipping address
 */

if (!defined("ENV")) exit();

if ($order->itemsCount > 0 && $user->auth_ok)
{

	// init
	$order->openShipping();
	$order->recalcOrderData();
	
	//country / state data
	require_once("content/classes/class.regions.php");
	$regions = new Regions($db);
	view()->assign("countries_states", json_encode($regions->getCountriesStatesForSite()));

	//shipping & billing addresses
	if ($oa == ORDER_UPDATE_BILLING_AND_SHIPPING_ADDRESS)
	{
		$billing_address = isset($_POST["billing_address"]) ? $_POST["billing_address"] : array();
		if ($user->is_error && isset($is_billing_error) && $is_billing_error)
		{
			view()->assign("billing_errors", $user->errors);
		}
		
		$shipping_address = isset($_POST["shipping_address"]) ? $_POST["shipping_address"] : array();
		if ($user->is_error && isset($is_shipping_error) && $is_shipping_error)
		{
			view()->assign("shipping_errors", $user->errors);
		}
	}
	else
	{
		$billing_address = $user->getUserData();
		if ($user->express && $billing_address["country"] == 0)
		{
			$billing_address["country"] = "-1";
			$billing_address["state"] = "-1";
		}
		$shipping_address = $order->getShippingAddress();
	}
	view()->assign("billing_address", $billing_address);
	view()->assign("shipping_address", $shipping_address);
	
	
	//shipping data
	$tc_shipping_address_id = isset($_SESSION["tc_shipping_address_id"])?$_SESSION["tc_shipping_address_id"]:"";
	view()->assign("tc_shipping_address_id", $tc_shipping_address_id);
	view()->assign("shipping_is_free", $order->shippingIsFree);
	view()->assign("shipping_is_digital", $order->shippingDigital);
	
	if ($user->auth_ok && !$user->express)
	{
		view()->assign("address_book", $user->getShippingAddresses());
	}
	else
	{
		view()->assign("address_book", false);
	}
	
	//check is paypal express checkout used
	if (isset($_SESSION["paypal_express_checkout_details"]))
	{
		$paypal_address = $_SESSION["paypal_express_checkout_details"];
		$_paypal_address = array(
			"usid" => "paypal_ec",
			"is_primary" => "Yes",
			"name" => $paypal_address["PayerInfo"][0]["Address"][0]["Name"][0],
			"company" => "",
			"address1" => $paypal_address["PayerInfo"][0]["Address"][0]["Street1"][0],
			"address2" => $paypal_address["PayerInfo"][0]["Address"][0]["Street2"][0],
			"city" => $paypal_address["PayerInfo"][0]["Address"][0]["CityName"][0],
			"state" => $paypal_address["PayerInfo"][0]["Address"][0]["StateOrProvince"][0],
			"province" => $paypal_address["PayerInfo"][0]["Address"][0]["StateOrProvince"][0],
			"zip" => $paypal_address["PayerInfo"][0]["Address"][0]["PostalCode"][0],
			"country" => $paypal_address["PayerInfo"][0]["Address"][0]["Country"][0],
			"country_name" => $paypal_address["PayerInfo"][0]["Address"][0]["CountryName"][0],
		);
		view()->assign("paypal_address", $_paypal_address);
	}
	else
	{
		view()->assign("paypal_address", false);
	}
		
	//custom fields
	$custom_field = isset($_REQUEST["custom_field"]) ? $_REQUEST["custom_field"] : array();
	view()->assign("cf_invoice", $cf_invoice = $custom_fields->GetCustomFieldsValues("invoice", $user->id, $order->oid, 0));
	view()->assign("body", "templates/pages/checkout/billing-and-shipping-address.html");
}
else
{
	header("Location: ".$url_dinamic."p=cart");
}
