<?php
/**
 * Show users cart
 */
	
	if (!defined("ENV")) exit();
	
	unset($_SESSION["user_started_checkout"]);
	require_once("content/classes/class.products.php");
		
	view()->assign("order_items", $order->getOrderItemsExtended($settings));
	
	//other stuff
	view()->assign("product_delete_url", 
		$settings["GlobalHttpUrl"]."/".$settings["INDEX"]."?oa=".ORDER_REMOVE_ITEM.
		"&backurl=".urlencode($settings["GlobalHttpUrl"]."/".$settings["INDEX"]."?".$_SERVER["QUERY_STRING"])."&oa_id="
	);
		
	if (isset($_REQUEST["promo_code"]))
	{
		$_SESSION["order_promo_code"] = $_REQUEST["promo_code"];
	}
	elseif (isset($_SESSION["order_promo_code"]))
	{
		$promo_code = $_SESSION["order_promo_code"];
	}
	else
	{
		$promo_code = "";
	}
	
	if (isset($_SESSION["remove_item_promo_error"]))
	{
		$promo_error = $_SESSION["remove_item_promo_error"];
		unset($_SESSION["remove_item_promo_error"]);
	}
	
	view()->assign("promo_error", isset($promo_error));
	view()->assign("promo_code", isset($_REQUEST["promo_code"]) ? $_REQUEST["promo_code"] : "");
	
	//check min subtotal amount
	$min_subtotal_amount = normalizeNumber($settings["MinOrderSubtotalLevel".$user->level]);
	$min_subtotal_error = $min_subtotal_amount > $order->subtotalAmount;
	
	view()->assign("min_subtotal_error", $min_subtotal_error);
	view()->assign("min_subtotal_amount", $min_subtotal_amount);
		
	if ($order->itemsCount > 0 && $settings["CustomerAlsoBoughtAvailable"] == "YES")
	{
		require_once("content/classes/class.products.php");
		$bs = new ShoppingCartProducts($db, $settings);
		$bs->taxRates = $order->taxRates;
		$bought_bestsellers = $bs->getItemsBestSellersByOrderContent($order->oid);
		if ($bought_bestsellers)
		{ 
			view()->assign("bought_bestsellers_file", "boxes/box_products_other_bought.html");
			view()->assign("bought_bestsellers", $bought_bestsellers);
			view()->assign("bought_bestsellers_view", $settings["CustomerAlsoBoughtView"]);
		}
	}
	
	// check for available payment methods
	$db->query("SELECT COUNT(0) FROM ".DB_PREFIX."payment_methods WHERE id NOT IN ('paypalec','googlecheckout') AND active='Yes'");
	$db->moveNext();
	view()->assign('totalPaymentMethods', $db->col[0]);
	
	//check paypal express payments
	view()->assign("paypal_ec_active", false);
	
	if ($order->totalAmount > 0)
	{		
		/////////////////////////////////////////
		//PAYPAL EXPRESS CHECKOUT
		$db->query("SELECT * FROM ".DB_PREFIX."payment_methods WHERE id='paypalec' AND active='Yes'");
		if ($db->moveNext())
		{
			unset($_SESSION["paypal_express_checkout_details"]);
			unset($_SESSION["google_checkout_used"]);
			
			view()->assign("paypal_ec_active", true);
			
			require_once("content/engine/engine_paypal_ec.php");
			
			$paypal_ec = new paypalExpressCheckout();
			$paypal_ec->ApiURL = $db->col["url_to_gateway"];
			
			//check for accelerated boaring mode
			if (trim($settings["paypalec_Email"]) != "")
			{
				$paypal_ec->Email = $settings["paypalec_Email"];
				$paypal_ec->PaymentAction = "Sale";
			}
			else
			{
				$paypal_ec->Username = $settings["paypalec_Username"];
				$paypal_ec->Password = $settings["paypalec_Password"];
				$paypal_ec->PaymentAction = $settings["paypalec_Payment_Action"];	
			}
			
			
			$paypal_ec->currencyCode = $settings["paypalec_currency"];
			$paypal_ec->ReturnURL = $url_https.'p=cart&oa='.ORDER_STORE_PAYPAL_EC_INFO;
			$paypal_ec->NoShipping = $order->shippingDigital;
			
			if (!$user->auth_ok)
			{
				$paypal_ec->ReturnURL = $paypal_ec->ReturnURL."&ua=".USER_EXPRESS_CHECKOUT;
			}
			
			$paypal_ec->CancelURL = $url_dinamic.'p=cart';
			$paypal_ec->OrderTotal = $order->totalAmount;
			
			$paypal_ec->mode = strtolower($settings["paypalec_Mode"]);
			
			//$paypal_ec->mode = "test";
			$paypal_ec_token = $paypal_ec->SetExpressCheckout();
			
			view()->assign("paypal_ec_is_error", $paypal_ec->is_error);
			if ($paypal_ec->is_error)
			{
				view()->assign("paypal_ec_errors", $paypal_ec->error_messages);
			}
			else
			{
				view()->assign("paypal_ec_url", $paypal_ec->getExpressCheckoutUrl($paypal_ec_token));
			}
		}
	}
	view()->assign("SERVER_PORT", $_SERVER["SERVER_PORT"]);
	view()->assign("body", "templates/pages/checkout/cart.html");