<?php
/**
 * Show one page checkout page
 */
if (!defined("ENV")) exit();

global $settings, $_SESSION, $payment, $msg;
	
if ($order->itemsCount > 0 && $user->auth_ok)
{
	$using_ie6 = (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE 6.') !== FALSE); 
	if ($using_ie6)
	{
		header("Location: ".$url_dinamic."p=billing_and_shipping_address");
	}
	else
	{
		$order->setOrderNum();
		$order->setAbandonStatus();
		view()->assign("order_num", $order->order_num);
		
		//check status
		$start = isset($_REQUEST["start"])?true:false;
		
		if ($start)
		{
			$order->openShipping();
			$order->recalcOrderData();		
		}
		else
		{
			$order->getOrderData();
			$order->getOrderItems();
		}
	
		$shipping_is_free = $order->shippingIsFree;
		$shipping_is_digital = $order->shippingDigital;
		
		//country / state data
		require_once("content/classes/class.regions.php");
		$regions = new Regions($db);
		$countries_states = $regions->getCountriesStatesForSite();
		view()->assign("countries_states", $countries_states);
	
		//billing data
		$user_data = $user->getUserData();
		if ($user->express && $user_data["country"] == 0)
		{
			$user_data["country"] = "-1";
			$user_data["state"] = "-1";
		}
		view()->assign("billing_address", $user_data);
	
		//shipping data
		$opc_shipping_address_id = isset($_SESSION["opc_shipping_address_id"])?$_SESSION["opc_shipping_address_id"]:"";
		view()->assign("opc_shipping_address_id", $opc_shipping_address_id);
		$shipping_address = $order->getShippingAddress();
		view()->assign("shipping_address", $shipping_address);
		view()->assign("shipping_is_free", $shipping_is_free);
		view()->assign("shipping_is_digital", $shipping_is_digital);
	
		if (isset($_SESSION["paypal_express_checkout_details"]))
		{
			view()->assign("paypal_ec_used", true);
			view()->assign("paypal_address", $user->GetShippingAddressById($opc_shipping_address_id));
		}
		else
		{
			view()->assign("paypal_ec_used", false);
			view()->assign("address_book", $user->GetShippingAddresses());
		}
		
		//payment
		if (!isset($payment))
		{
			$payment = new PAYMENT($db);
		}
		
		// TODO: Moneybookers to work in OPC
		// Temporarily keeping moneybookers from being used in OPC
		$moneybookers_count = 0;	
		foreach ($payment->methods as $method)
		{
			if (in_array($method->id, array('moneybookers', 'moneybookersacc', 'moneybookersewallet')))
				$moneybookers_count++;
		}
		
		view()->assign("payment_methods", $payment->methods);
		view()->assign("payment_methods_count", count($payment->methods) - $moneybookers_count);
		ini_set('error_reporting', E_ALL);
		//add free payment method
		$free_payment_method = new PAYMENT_METHOD(
			0, // pid
			"http", // proto
			"custom", // type
			"", // url to gateway
			"Free", // name
			$msg["billing"]["order_is_free_title"], // form title
			$msg["billing"]["order_is_free_text"], // message payment
			"", // message thak you
			"free", // id
			""
		);
		
		$free_payment_method->payment_url = $url_https."p=one_page_checkout";
		$payment_method->payment_url = $url_https."p=one_page_checkout";
		
		view()->assign("free_payment_method", $free_payment_method);		
		view()->assign("is_payment_error", $payment->is_error?"yes":"no");
		view()->assign("payment_error_message", $payment->error_message);
		
		view()->assign("start", $start);
		view()->assign("current_currency", $_SESSION["current_currency"]);
		view()->assign("order", $order);
		
		//custom fields
		$custom_field = isset($_REQUEST["custom_field"]) ? $_REQUEST["custom_field"] : array();
		view()->assign("cf_invoice", $cf_invoice = $custom_fields->GetCustomFieldsValues("invoice", $user->id, $order->oid, 0));
		view()->assign("body", "templates/pages/checkout/one-page-checkout.html");
	}
}
else
{
	header("Location: ".$url_dinamic."p=cart");
}